def hardtanh(input: Tensor,
    min_val: float=-1.,
    max_val: float=1.,
    inplace: bool=False) -> Tensor:
  if inplace:
    result0 = torch.hardtanh_(input, min_val, max_val)
    result = result0
  else:
    result1 = torch.hardtanh(input, min_val, max_val)
    result = result1
  return result
def _max_pool2d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0, 0],
    dilation: List[int]=[1, 1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _0 = torch.max_pool2d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _0
def binary_cross_entropy_with_logits(input: Tensor,
    target: Tensor,
    weight: Optional[Tensor]=None,
    size_average: Optional[bool]=None,
    reduce: Optional[bool]=None,
    reduction: str="mean",
    pos_weight: Optional[Tensor]=None) -> Tensor:
  _1 = __torch__.torch.nn._reduction.legacy_get_enum
  _2 = __torch__.torch.nn._reduction.get_enum
  _3 = "Target size ({}) must be the same as input size ({})"
  if torch.__isnot__(size_average, None):
    _4, size_average0 = True, unchecked_cast(bool, size_average)
  else:
    _4, size_average0 = torch.__isnot__(reduce, None), size_average
  if _4:
    reduction_enum = _1(size_average0, reduce, True, )
  else:
    reduction_enum = _2(reduction, )
  _5 = torch.eq(torch.size(target), torch.size(input))
  if torch.__not__(_5):
    _6 = torch.format(_3, torch.size(target), torch.size(input))
    ops.prim.RaiseException(_6)
  else:
    pass
  _7 = torch.binary_cross_entropy_with_logits(input, target, weight, pos_weight, reduction_enum)
  return _7
def relu(input: Tensor,
    inplace: bool=False) -> Tensor:
  if inplace:
    result = torch.relu_(input)
  else:
    result = torch.relu(input)
  return result
def softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _8 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim1 = _8("softmax", torch.dim(input), _stacklevel, )
    dim0 = dim1
  else:
    dim0 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret = torch.softmax(input, dim0, None)
  else:
    dtype0 = unchecked_cast(int, dtype)
    ret = torch.softmax(input, dim0, dtype0)
  return ret
def linear(input: Tensor,
    weight: Tensor,
    bias: Optional[Tensor]=None) -> Tensor:
  return torch.linear(input, weight, bias)
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _9 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _9:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _10 = torch.adaptive_avg_pool2d(input, output_size)
  return _10
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _11 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _11:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _12 = torch.adaptive_avg_pool3d(input, output_size)
  return _12
def cross_entropy(input: Tensor,
    target: Tensor,
    weight: Optional[Tensor]=None,
    size_average: Optional[bool]=None,
    ignore_index: int=-100,
    reduce: Optional[bool]=None,
    reduction: str="mean") -> Tensor:
  _13 = __torch__.torch.nn._reduction.legacy_get_string
  _14 = __torch__.torch.nn.functional.log_softmax
  _15 = __torch__.torch.nn.functional.nll_loss
  if torch.__isnot__(size_average, None):
    _16, size_average1 = True, unchecked_cast(bool, size_average)
  else:
    _16, size_average1 = torch.__isnot__(reduce, None), size_average
  if _16:
    reduction0 = _13(size_average1, reduce, True, )
  else:
    reduction0 = reduction
  _17 = _15(_14(input, 1, 3, None, ), target, weight, None, ignore_index, None, reduction0, )
  return _17
def _get_softmax_dim(name: str,
    ndim: int,
    stacklevel: int) -> int:
  _18 = "Implicit dimension choice for {} has been deprecated. Change the call to include dim=X as an argument."
  torch.warn(torch.format(_18, name), stacklevel)
  if torch.eq(ndim, 0):
    _19 = True
  else:
    _19 = torch.eq(ndim, 1)
  if _19:
    _20 = True
  else:
    _20 = torch.eq(ndim, 3)
  if _20:
    ret = 0
  else:
    ret = 1
  return ret
def _pad(input: Tensor,
    pad: List[int],
    mode: str="constant",
    value: float=0.) -> Tensor:
  _21 = "AssertionError: Padding length must be divisible by 2"
  _22 = "AssertionError: Padding length too large"
  _23 = "Padding mode \"{}\"\" doesn\'t take in value argument"
  _24 = "AssertionError: 3D tensors expect 2 values for padding"
  _25 = __torch__.torch.nn.functional._pad_circular
  _26 = "AssertionError: 4D tensors expect 4 values for padding"
  _27 = "AssertionError: 5D tensors expect 6 values for padding"
  _28 = "Only 3D, 4D, 5D padding with non-constant padding are supported for now"
  _29 = uninitialized(Tensor)
  _30 = torch.eq(torch.remainder(torch.len(pad), 2), 0)
  if _30:
    pass
  else:
    ops.prim.RaiseException(_21)
  _31 = torch.le(torch.floordiv(torch.len(pad), 2), torch.dim(input))
  if _31:
    pass
  else:
    ops.prim.RaiseException(_22)
  if torch.eq(mode, "constant"):
    _33 = torch.constant_pad_nd(input, pad, value)
    _32 = _33
  else:
    if torch.eq(value, 0):
      pass
    else:
      _34 = torch.add("AssertionError: ", torch.format(_23, mode))
      ops.prim.RaiseException(_34)
    if torch.eq(torch.dim(input), 3):
      if torch.eq(torch.len(pad), 2):
        pass
      else:
        ops.prim.RaiseException(_24)
      if torch.eq(mode, "reflect"):
        _37 = torch.reflection_pad1d(input, pad)
        _36 = _37
      else:
        if torch.eq(mode, "replicate"):
          _39 = torch.replication_pad1d(input, pad)
          _38 = _39
        else:
          if torch.eq(mode, "circular"):
            _40 = _25(input, pad, )
          else:
            ops.prim.RaiseException("")
            _40 = _29
          _38 = _40
        _36 = _38
      _35 = _36
    else:
      if torch.eq(torch.dim(input), 4):
        if torch.eq(torch.len(pad), 4):
          pass
        else:
          ops.prim.RaiseException(_26)
        if torch.eq(mode, "reflect"):
          _43 = torch.reflection_pad2d(input, pad)
          _42 = _43
        else:
          if torch.eq(mode, "replicate"):
            _45 = torch.replication_pad2d(input, pad)
            _44 = _45
          else:
            if torch.eq(mode, "circular"):
              _46 = _25(input, pad, )
            else:
              ops.prim.RaiseException("")
              _46 = _29
            _44 = _46
          _42 = _44
        _41 = _42
      else:
        if torch.eq(torch.dim(input), 5):
          if torch.eq(torch.len(pad), 6):
            pass
          else:
            ops.prim.RaiseException(_27)
          if torch.eq(mode, "reflect"):
            ops.prim.RaiseException("")
            _48 = _29
          else:
            if torch.eq(mode, "replicate"):
              _50 = torch.replication_pad3d(input, pad)
              _49 = _50
            else:
              _51 = torch.eq(mode, "circular")
              if _51:
                _52 = _25(input, pad, )
              else:
                ops.prim.RaiseException("")
                _52 = _29
              _49 = _52
            _48 = _49
          _47 = _48
        else:
          ops.prim.RaiseException(_28)
          _47 = _29
        _41 = _47
      _35 = _41
    _32 = _35
  return _32
def log_softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _53 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim3 = _53("log_softmax", torch.dim(input), _stacklevel, )
    dim2 = dim3
  else:
    dim2 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret0 = torch.log_softmax(input, dim2, None)
    ret = ret0
  else:
    dtype1 = unchecked_cast(int, dtype)
    ret1 = torch.log_softmax(input, dim2, dtype1)
    ret = ret1
  return ret
def nll_loss(input: Tensor,
    target: Tensor,
    weight: Optional[Tensor]=None,
    size_average: Optional[bool]=None,
    ignore_index: int=-100,
    reduce: Optional[bool]=None,
    reduction: str="mean") -> Tensor:
  _54 = __torch__.torch.nn._reduction.legacy_get_string
  _55 = "Expected 2 or more dimensions (got {})"
  _56 = "Expected input batch_size ({}) to match target batch_size ({})."
  _57 = __torch__.torch.nn._reduction.get_enum
  if torch.__isnot__(size_average, None):
    _58, size_average2 = True, unchecked_cast(bool, size_average)
  else:
    _58, size_average2 = torch.__isnot__(reduce, None), size_average
  if _58:
    reduction1 = _54(size_average2, reduce, True, )
  else:
    reduction1 = reduction
  dim = torch.dim(input)
  if torch.lt(dim, 2):
    ops.prim.RaiseException(torch.format(_55, dim))
  else:
    pass
  _59 = torch.ne(torch.size(input, 0), torch.size(target, 0))
  if _59:
    _60 = torch.format(_56, torch.size(input, 0), torch.size(target, 0))
    ops.prim.RaiseException(_60)
  else:
    pass
  if torch.eq(dim, 2):
    ret2 = torch.nll_loss(input, target, weight, _57(reduction1, ), ignore_index)
    ret = ret2
  else:
    if torch.eq(dim, 4):
      ret4 = torch.nll_loss2d(input, target, weight, _57(reduction1, ), ignore_index)
      ret3 = ret4
    else:
      n = torch.size(input, 0)
      c = torch.size(input, 1)
      _61 = torch.slice(torch.size(input), 2, 9223372036854775807, 1)
      out_size = torch.add([n], _61)
      _62 = torch.slice(torch.size(target), 1, 9223372036854775807, 1)
      _63 = torch.slice(torch.size(input), 2, 9223372036854775807, 1)
      if torch.ne(_62, _63):
        _64 = torch.format("Expected target size {}, got {}", out_size, torch.size(target))
        ops.prim.RaiseException(_64)
      else:
        pass
      input0 = torch.contiguous(input, memory_format=0)
      target0 = torch.contiguous(target, memory_format=0)
      if torch.gt(torch.numel(input0), 0):
        input2 = torch.view(input0, [n, c, 1, -1])
        input1 = input2
      else:
        input3 = torch.view(input0, [n, c, 0, 0])
        input1 = input3
      if torch.gt(torch.numel(target0), 0):
        target1 = torch.view(target0, [n, 1, -1])
      else:
        target1 = torch.view(target0, [n, 0, 0])
      reduction_enum = _57(reduction1, )
      if torch.ne(reduction1, "none"):
        ret6 = torch.nll_loss2d(input1, target1, weight, reduction_enum, ignore_index)
        ret5 = ret6
      else:
        out = torch.nll_loss2d(input1, target1, weight, reduction_enum, ignore_index)
        ret5 = torch.view(out, out_size)
      ret3 = ret5
    ret = ret3
  return ret
def _pad_circular(input: Tensor,
    padding: List[int]) -> Tensor:
  _65 = "AssertionError: Padding value causes wrapping around more than once."
  _66 = "AssertionError: Negative padding value is resulting in an empty dimension."
  in_shape = torch.size(input)
  paddable_shape = torch.slice(in_shape, 2, 9223372036854775807, 1)
  ndim = torch.len(paddable_shape)
  _67 = [9223372036854775807, torch.len(paddable_shape)]
  for idx in range(ops.prim.min(_67)):
    size = paddable_shape[idx]
    _68 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    if torch.le(padding[_68], size):
      pass
    else:
      ops.prim.RaiseException(_65)
    _69 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    if torch.le(padding[_69], size):
      pass
    else:
      ops.prim.RaiseException(_65)
    _70 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    _71 = padding[_70]
    _72 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    _73 = torch.add(torch.add(_71, padding[_72]), size)
    if torch.ge(_73, 0):
      pass
    else:
      ops.prim.RaiseException(_66)
  out_shape = torch.slice(in_shape, 0, 2, 1)
  _74 = [9223372036854775807, torch.len(paddable_shape)]
  out_shape0 = out_shape
  for idx0 in range(ops.prim.min(_74)):
    size0 = paddable_shape[idx0]
    _75 = torch.neg(torch.add(torch.mul(idx0, 2), 1))
    _76 = torch.add(size0, padding[_75])
    _77 = torch.neg(torch.add(torch.mul(idx0, 2), 2))
    out_shape1 = torch.add_(out_shape0, [torch.add(_76, padding[_77])])
    out_shape0 = out_shape1
  out = torch.empty(out_shape0, dtype=ops.prim.dtype(input), layout=ops.prim.layout(input), device=ops.prim.device(input), pin_memory=None, memory_format=None)
  if torch.eq(ndim, 1):
    out_d0 = ops.prim.max(padding[-2], 0)
    out_d1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    in_d0 = ops.prim.max(torch.neg(padding[-2]), 0)
    _78 = in_shape[2]
    _79 = ops.prim.max(torch.neg(padding[-1]), 0)
    in_d1 = torch.sub(_78, _79)
    _80 = torch.slice(input, -1, in_d0, in_d1, 1)
    _81 = torch.slice(out, -1, out_d0, out_d1, 1)
    _82 = torch.copy_(_81, _80, False)
  else:
    if torch.eq(ndim, 2):
      out_d00 = ops.prim.max(padding[-2], 0)
      out_d10 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
      out_h0 = ops.prim.max(padding[-4], 0)
      out_h1 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      in_d00 = ops.prim.max(torch.neg(padding[-2]), 0)
      _83 = in_shape[2]
      _84 = ops.prim.max(torch.neg(padding[-1]), 0)
      in_d10 = torch.sub(_83, _84)
      in_h0 = ops.prim.max(torch.neg(padding[-4]), 0)
      _85 = in_shape[3]
      _86 = ops.prim.max(torch.neg(padding[-3]), 0)
      in_h1 = torch.sub(_85, _86)
      _87 = torch.slice(input, -2, in_d00, in_d10, 1)
      _88 = torch.slice(_87, -1, in_h0, in_h1, 1)
      _89 = torch.slice(out, -2, out_d00, out_d10, 1)
      _90 = torch.slice(_89, -1, out_h0, out_h1, 1)
      _91 = torch.copy_(_90, _88, False)
    else:
      if torch.eq(ndim, 3):
        out_d01 = ops.prim.max(padding[-2], 0)
        out_d11 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
        out_h00 = ops.prim.max(padding[-4], 0)
        out_h10 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
        out_w0 = ops.prim.max(padding[-6], 0)
        out_w1 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
        in_d01 = ops.prim.max(torch.neg(padding[-2]), 0)
        _92 = in_shape[2]
        _93 = ops.prim.max(torch.neg(padding[-1]), 0)
        in_d11 = torch.sub(_92, _93)
        in_h00 = ops.prim.max(torch.neg(padding[-4]), 0)
        _94 = in_shape[3]
        _95 = ops.prim.max(torch.neg(padding[-3]), 0)
        in_h10 = torch.sub(_94, _95)
        in_w0 = ops.prim.max(torch.neg(padding[-6]), 0)
        _96 = in_shape[4]
        _97 = ops.prim.max(torch.neg(padding[-5]), 0)
        in_w1 = torch.sub(_96, _97)
        _98 = torch.slice(input, -3, in_d01, in_d11, 1)
        _99 = torch.slice(_98, -2, in_h00, in_h10, 1)
        _100 = torch.slice(_99, -1, in_w0, in_w1, 1)
        _101 = torch.slice(out, -3, out_d01, out_d11, 1)
        _102 = torch.slice(_101, -2, out_h00, out_h10, 1)
        _103 = torch.slice(_102, -1, out_w0, out_w1, 1)
        _104 = torch.copy_(_103, _100, False)
      else:
        pass
  if torch.gt(padding[-2], 0):
    _105 = torch.sub(out_shape0[2], padding[-2])
    i0 = torch.sub(_105, ops.prim.max(padding[-1], 0))
    i1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    o1 = padding[-2]
    _106 = torch.slice(out, 0, 0, 9223372036854775807, 1)
    _107 = torch.slice(_106, 1, 0, 9223372036854775807, 1)
    _108 = torch.slice(_107, 2, i0, i1, 1)
    _109 = torch.slice(out, 0, 0, 9223372036854775807, 1)
    _110 = torch.slice(_109, 1, 0, 9223372036854775807, 1)
    _111 = torch.copy_(torch.slice(_110, 2, 0, o1, 1), _108, False)
  else:
    pass
  if torch.gt(padding[-1], 0):
    i00 = ops.prim.max(padding[-2], 0)
    i10 = torch.add(ops.prim.max(padding[-2], 0), padding[-1])
    o0 = torch.sub(out_shape0[2], padding[-1])
    o10 = out_shape0[2]
    _112 = torch.slice(out, 0, 0, 9223372036854775807, 1)
    _113 = torch.slice(_112, 1, 0, 9223372036854775807, 1)
    _114 = torch.slice(_113, 2, i00, i10, 1)
    _115 = torch.slice(out, 0, 0, 9223372036854775807, 1)
    _116 = torch.slice(_115, 1, 0, 9223372036854775807, 1)
    _117 = torch.copy_(torch.slice(_116, 2, o0, o10, 1), _114, False)
  else:
    pass
  if torch.gt(torch.len(padding), 2):
    if torch.gt(padding[-4], 0):
      _118 = torch.sub(out_shape0[3], padding[-4])
      i01 = torch.sub(_118, ops.prim.max(padding[-3], 0))
      i11 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      o11 = padding[-4]
      _119 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _120 = torch.slice(_119, 1, 0, 9223372036854775807, 1)
      _121 = torch.slice(_120, 2, 0, 9223372036854775807, 1)
      _122 = torch.slice(_121, 3, i01, i11, 1)
      _123 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _124 = torch.slice(_123, 1, 0, 9223372036854775807, 1)
      _125 = torch.slice(_124, 2, 0, 9223372036854775807, 1)
      _126 = torch.copy_(torch.slice(_125, 3, 0, o11, 1), _122, False)
    else:
      pass
    if torch.gt(padding[-3], 0):
      i02 = ops.prim.max(padding[-4], 0)
      i12 = torch.add(ops.prim.max(padding[-4], 0), padding[-3])
      o00 = torch.sub(out_shape0[3], padding[-3])
      o12 = out_shape0[3]
      _127 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _128 = torch.slice(_127, 1, 0, 9223372036854775807, 1)
      _129 = torch.slice(_128, 2, 0, 9223372036854775807, 1)
      _130 = torch.slice(_129, 3, i02, i12, 1)
      _131 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _132 = torch.slice(_131, 1, 0, 9223372036854775807, 1)
      _133 = torch.slice(_132, 2, 0, 9223372036854775807, 1)
      _134 = torch.copy_(torch.slice(_133, 3, o00, o12, 1), _130, False)
    else:
      pass
  else:
    pass
  if torch.gt(torch.len(padding), 4):
    if torch.gt(padding[-6], 0):
      _135 = torch.sub(out_shape0[4], padding[-6])
      i03 = torch.sub(_135, ops.prim.max(padding[-5], 0))
      i13 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
      o13 = padding[-6]
      _136 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _137 = torch.slice(_136, 1, 0, 9223372036854775807, 1)
      _138 = torch.slice(_137, 2, 0, 9223372036854775807, 1)
      _139 = torch.slice(_138, 3, 0, 9223372036854775807, 1)
      _140 = torch.slice(_139, 4, i03, i13, 1)
      _141 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _142 = torch.slice(_141, 1, 0, 9223372036854775807, 1)
      _143 = torch.slice(_142, 2, 0, 9223372036854775807, 1)
      _144 = torch.slice(_143, 3, 0, 9223372036854775807, 1)
      _145 = torch.copy_(torch.slice(_144, 4, 0, o13, 1), _140, False)
    else:
      pass
    if torch.gt(padding[-5], 0):
      i04 = ops.prim.max(padding[-6], 0)
      i14 = torch.add(ops.prim.max(padding[-6], 0), padding[-5])
      o01 = torch.sub(out_shape0[4], padding[-5])
      o14 = out_shape0[4]
      _146 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _147 = torch.slice(_146, 1, 0, 9223372036854775807, 1)
      _148 = torch.slice(_147, 2, 0, 9223372036854775807, 1)
      _149 = torch.slice(_148, 3, 0, 9223372036854775807, 1)
      _150 = torch.slice(_149, 4, i04, i14, 1)
      _151 = torch.slice(out, 0, 0, 9223372036854775807, 1)
      _152 = torch.slice(_151, 1, 0, 9223372036854775807, 1)
      _153 = torch.slice(_152, 2, 0, 9223372036854775807, 1)
      _154 = torch.slice(_153, 3, 0, 9223372036854775807, 1)
      _155 = torch.copy_(torch.slice(_154, 4, o01, o14, 1), _150, False)
    else:
      pass
  else:
    pass
  return out
