class BoxCoder:
  weights : Tuple[float, float, float, float]
  bbox_xform_clip : float
  def __init__(self: __torch__.torchvision.models.detection._utils.BoxCoder,
    weights: Tuple[float, float, float, float],
    bbox_xform_clip: float=4.1351665567423561) -> None:
    self.weights = weights
    self.bbox_xform_clip = bbox_xform_clip
    return None
  def decode(self: __torch__.torchvision.models.detection._utils.BoxCoder,
    rel_codes: Tensor,
    boxes: List[Tensor]) -> Tensor:
    rel_codes0 = unchecked_cast(Tensor, rel_codes)
    boxes_per_image = annotate(List[int], [])
    for _0 in range(torch.len(boxes)):
      b = boxes[_0]
      _1 = torch.append(boxes_per_image, torch.size(b, 0))
    concat_boxes = torch.cat(boxes, 0)
    box_sum = 0
    for _2 in range(torch.len(boxes_per_image)):
      val = boxes_per_image[_2]
      box_sum = torch.add(box_sum, val)
    if torch.gt(box_sum, 0):
      rel_codes2 = torch.reshape(rel_codes0, [box_sum, -1])
      rel_codes1 = rel_codes2
    else:
      rel_codes1 = rel_codes0
    pred_boxes = (self).decode_single(rel_codes1, concat_boxes, )
    if torch.gt(box_sum, 0):
      pred_boxes1 = torch.reshape(pred_boxes, [box_sum, -1, 4])
      pred_boxes0 = pred_boxes1
    else:
      pred_boxes0 = pred_boxes
    return pred_boxes0
  def decode_single(self: __torch__.torchvision.models.detection._utils.BoxCoder,
    rel_codes: Tensor,
    boxes: Tensor) -> Tensor:
    boxes0 = torch.to(boxes, ops.prim.dtype(rel_codes), False, False, None)
    _3 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    _4 = torch.select(_3, 1, 2)
    _5 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    widths = torch.sub(_4, torch.select(_5, 1, 0), alpha=1)
    _6 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    _7 = torch.select(_6, 1, 3)
    _8 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    heights = torch.sub(_7, torch.select(_8, 1, 1), alpha=1)
    _9 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    ctr_x = torch.add(torch.select(_9, 1, 0), torch.mul(widths, 0.5), alpha=1)
    _10 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
    ctr_y = torch.add(torch.select(_10, 1, 1), torch.mul(heights, 0.5), alpha=1)
    wx, wy, ww, wh, = self.weights
    _11 = torch.slice(rel_codes, 0, 0, 9223372036854775807, 1)
    _12 = torch.slice(_11, 1, 0, 9223372036854775807, 4)
    dx = torch.div(_12, wx)
    _13 = torch.slice(rel_codes, 0, 0, 9223372036854775807, 1)
    _14 = torch.slice(_13, 1, 1, 9223372036854775807, 4)
    dy = torch.div(_14, wy)
    _15 = torch.slice(rel_codes, 0, 0, 9223372036854775807, 1)
    _16 = torch.slice(_15, 1, 2, 9223372036854775807, 4)
    dw = torch.div(_16, ww)
    _17 = torch.slice(rel_codes, 0, 0, 9223372036854775807, 1)
    _18 = torch.slice(_17, 1, 3, 9223372036854775807, 4)
    dh = torch.div(_18, wh)
    dw0 = torch.clamp(dw, None, self.bbox_xform_clip)
    dh0 = torch.clamp(dh, None, self.bbox_xform_clip)
    _19 = torch.slice(widths, 0, 0, 9223372036854775807, 1)
    _20 = torch.mul(dx, torch.unsqueeze(_19, 1))
    _21 = torch.slice(ctr_x, 0, 0, 9223372036854775807, 1)
    pred_ctr_x = torch.add(_20, torch.unsqueeze(_21, 1), alpha=1)
    _22 = torch.slice(heights, 0, 0, 9223372036854775807, 1)
    _23 = torch.mul(dy, torch.unsqueeze(_22, 1))
    _24 = torch.slice(ctr_y, 0, 0, 9223372036854775807, 1)
    pred_ctr_y = torch.add(_23, torch.unsqueeze(_24, 1), alpha=1)
    _25 = torch.exp(dw0)
    _26 = torch.slice(widths, 0, 0, 9223372036854775807, 1)
    pred_w = torch.mul(_25, torch.unsqueeze(_26, 1))
    _27 = torch.exp(dh0)
    _28 = torch.slice(heights, 0, 0, 9223372036854775807, 1)
    pred_h = torch.mul(_27, torch.unsqueeze(_28, 1))
    _29 = torch.tensor(0.5, dtype=ops.prim.dtype(pred_ctr_x), device=ops.prim.device(pred_w), requires_grad=False)
    pred_boxes1 = torch.sub(pred_ctr_x, torch.mul(_29, pred_w), alpha=1)
    _30 = torch.tensor(0.5, dtype=ops.prim.dtype(pred_ctr_y), device=ops.prim.device(pred_h), requires_grad=False)
    pred_boxes2 = torch.sub(pred_ctr_y, torch.mul(_30, pred_h), alpha=1)
    _31 = torch.tensor(0.5, dtype=ops.prim.dtype(pred_ctr_x), device=ops.prim.device(pred_w), requires_grad=False)
    pred_boxes3 = torch.add(pred_ctr_x, torch.mul(_31, pred_w), alpha=1)
    _32 = torch.tensor(0.5, dtype=ops.prim.dtype(pred_ctr_y), device=ops.prim.device(pred_h), requires_grad=False)
    pred_boxes4 = torch.add(pred_ctr_y, torch.mul(_32, pred_h), alpha=1)
    _33 = [pred_boxes1, pred_boxes2, pred_boxes3, pred_boxes4]
    pred_boxes = torch.flatten(torch.stack(_33, 2), 1, -1)
    return pred_boxes
  def encode(self: __torch__.torchvision.models.detection._utils.BoxCoder,
    reference_boxes: List[Tensor],
    proposals: List[Tensor]) -> List[Tensor]:
    boxes_per_image = annotate(List[int], [])
    for _34 in range(torch.len(reference_boxes)):
      b = reference_boxes[_34]
      _35 = torch.append(boxes_per_image, torch.len(b))
    reference_boxes0 = torch.cat(reference_boxes, 0)
    proposals0 = torch.cat(proposals, 0)
    targets = (self).encode_single(reference_boxes0, proposals0, )
    _36 = torch.split(targets, boxes_per_image, 0)
    return _36
  def encode_single(self: __torch__.torchvision.models.detection._utils.BoxCoder,
    reference_boxes: Tensor,
    proposals: Tensor) -> Tensor:
    _37 = __torch__.torchvision.models.detection._utils.encode_boxes
    dtype = ops.prim.dtype(reference_boxes)
    device = ops.prim.device(reference_boxes)
    _38, _39, _40, _41, = self.weights
    weights = torch.as_tensor([_38, _39, _40, _41], dtype=dtype, device=device)
    targets = _37(reference_boxes, proposals, weights, )
    return targets
class Matcher:
  BELOW_LOW_THRESHOLD : int
  BETWEEN_THRESHOLDS : int
  high_threshold : float
  low_threshold : float
  allow_low_quality_matches : bool
  def __call__(self: __torch__.torchvision.models.detection._utils.Matcher,
    match_quality_matrix: Tensor) -> Tensor:
    _42 = "No ground-truth boxes available for one of the images during training"
    _43 = "No proposal boxes available for one of the images during training"
    _44 = uninitialized(Tensor)
    _45 = torch.eq(torch.numel(match_quality_matrix), 0)
    if _45:
      _46 = (torch.size(match_quality_matrix))[0]
      if torch.eq(_46, 0):
        ops.prim.RaiseException(_42)
      else:
        ops.prim.RaiseException(_43)
    else:
      pass
    matched_vals, matches = torch.max(match_quality_matrix, 0, False)
    if self.allow_low_quality_matches:
      all_matches0 = torch.clone(matches, memory_format=None)
      all_matches = all_matches0
    else:
      all_matches = None
    below_low_threshold = torch.lt(matched_vals, self.low_threshold)
    _47 = torch.ge(matched_vals, self.low_threshold)
    _48 = torch.lt(matched_vals, self.high_threshold)
    between_thresholds = torch.__and__(_47, _48)
    _49 = torch.tensor(self.BELOW_LOW_THRESHOLD, dtype=ops.prim.dtype(matches), device=ops.prim.device(matches), requires_grad=False)
    _50 = annotate(List[Optional[Tensor]], [below_low_threshold])
    _51 = torch.index_put_(matches, _50, _49, False)
    _52 = torch.tensor(self.BETWEEN_THRESHOLDS, dtype=ops.prim.dtype(matches), device=ops.prim.device(matches), requires_grad=False)
    _53 = annotate(List[Optional[Tensor]], [between_thresholds])
    _54 = torch.index_put_(matches, _53, _52, False)
    if self.allow_low_quality_matches:
      _55 = torch.__isnot__(all_matches, None)
      if _55:
        all_matches2 = unchecked_cast(Tensor, all_matches)
        all_matches1 = all_matches2
      else:
        ops.prim.RaiseException("AssertionError: ")
        all_matches1 = _44
      _56 = (self).set_low_quality_matches_(matches, all_matches1, match_quality_matrix, )
    else:
      pass
    return matches
  def __init__(self: __torch__.torchvision.models.detection._utils.Matcher,
    high_threshold: float,
    low_threshold: float,
    allow_low_quality_matches: bool=False) -> None:
    self.BELOW_LOW_THRESHOLD = -1
    self.BETWEEN_THRESHOLDS = -2
    _57 = torch.le(low_threshold, high_threshold)
    if _57:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    self.high_threshold = high_threshold
    self.low_threshold = low_threshold
    self.allow_low_quality_matches = allow_low_quality_matches
    return None
  def set_low_quality_matches_(self: __torch__.torchvision.models.detection._utils.Matcher,
    matches: Tensor,
    all_matches: Tensor,
    match_quality_matrix: Tensor) -> None:
    highest_quality_foreach_gt, _58 = torch.max(match_quality_matrix, 1, False)
    _59 = torch.slice(highest_quality_foreach_gt, 0, 0, 9223372036854775807, 1)
    _60 = torch.eq(match_quality_matrix, torch.unsqueeze(_59, 1))
    gt_pred_pairs_of_highest_quality = torch.where(_60)
    pred_inds_to_update = gt_pred_pairs_of_highest_quality[1]
    _61 = annotate(List[Optional[Tensor]], [pred_inds_to_update])
    _62 = torch.index(all_matches, _61)
    _63 = annotate(List[Optional[Tensor]], [pred_inds_to_update])
    _64 = torch.index_put_(matches, _63, _62, False)
    return None
class BalancedPositiveNegativeSampler:
  batch_size_per_image : int
  positive_fraction : float
  def __call__(self: __torch__.torchvision.models.detection._utils.BalancedPositiveNegativeSampler,
    matched_idxs: List[Tensor]) -> Tuple[List[Tensor], List[Tensor]]:
    pos_idx = annotate(List[Tensor], [])
    neg_idx = annotate(List[Tensor], [])
    for _65 in range(torch.len(matched_idxs)):
      matched_idxs_per_image = matched_idxs[_65]
      _66 = torch.ge(matched_idxs_per_image, 1)
      positive = (torch.where(_66))[0]
      _67 = torch.eq(matched_idxs_per_image, 0)
      negative = (torch.where(_67))[0]
      _68 = torch.mul(self.batch_size_per_image, self.positive_fraction)
      num_pos = int(_68)
      num_pos0 = ops.prim.min(torch.numel(positive), num_pos)
      num_neg = torch.sub(self.batch_size_per_image, num_pos0)
      num_neg0 = ops.prim.min(torch.numel(negative), num_neg)
      _69 = torch.randperm(torch.numel(positive), dtype=4, layout=None, device=ops.prim.device(positive), pin_memory=None)
      perm1 = torch.slice(_69, 0, 0, num_pos0, 1)
      _70 = torch.randperm(torch.numel(negative), dtype=4, layout=None, device=ops.prim.device(negative), pin_memory=None)
      perm2 = torch.slice(_70, 0, 0, num_neg0, 1)
      _71 = annotate(List[Optional[Tensor]], [perm1])
      pos_idx_per_image = torch.index(positive, _71)
      _72 = annotate(List[Optional[Tensor]], [perm2])
      neg_idx_per_image = torch.index(negative, _72)
      pos_idx_per_image_mask = torch.zeros_like(matched_idxs_per_image, dtype=0, layout=None, device=None, pin_memory=None, memory_format=None)
      neg_idx_per_image_mask = torch.zeros_like(matched_idxs_per_image, dtype=0, layout=None, device=None, pin_memory=None, memory_format=None)
      _73 = ops.prim.dtype(pos_idx_per_image_mask)
      _74 = ops.prim.device(pos_idx_per_image_mask)
      _75 = torch.tensor(1, dtype=_73, device=_74, requires_grad=False)
      _76 = annotate(List[Optional[Tensor]], [pos_idx_per_image])
      _77 = torch.index_put_(pos_idx_per_image_mask, _76, _75, False)
      _78 = ops.prim.dtype(neg_idx_per_image_mask)
      _79 = ops.prim.device(neg_idx_per_image_mask)
      _80 = torch.tensor(1, dtype=_78, device=_79, requires_grad=False)
      _81 = annotate(List[Optional[Tensor]], [neg_idx_per_image])
      _82 = torch.index_put_(neg_idx_per_image_mask, _81, _80, False)
      _83 = torch.append(pos_idx, pos_idx_per_image_mask)
      _84 = torch.append(neg_idx, neg_idx_per_image_mask)
    return (pos_idx, neg_idx)
  def __init__(self: __torch__.torchvision.models.detection._utils.BalancedPositiveNegativeSampler,
    batch_size_per_image: int,
    positive_fraction: float) -> None:
    self.batch_size_per_image = batch_size_per_image
    self.positive_fraction = positive_fraction
    return None
def smooth_l1_loss(input: Tensor,
    target: Tensor,
    beta: float=0.1111111111111111,
    size_average: bool=True) -> Tensor:
  n = torch.abs(torch.sub(input, target, alpha=1))
  cond = torch.lt(n, beta)
  _85 = torch.div(torch.mul(torch.pow(n, 2), 0.5), beta)
  loss = torch.where(cond, _85, torch.sub(n, torch.mul(0.5, beta), 1))
  if size_average:
    _86 = torch.mean(loss, dtype=None)
  else:
    _86 = torch.sum(loss, dtype=None)
  return _86
def encode_boxes(reference_boxes: Tensor,
    proposals: Tensor,
    weights: Tensor) -> Tensor:
  wx = torch.select(weights, 0, 0)
  wy = torch.select(weights, 0, 1)
  ww = torch.select(weights, 0, 2)
  wh = torch.select(weights, 0, 3)
  _87 = torch.slice(proposals, 0, 0, 9223372036854775807, 1)
  proposals_x1 = torch.unsqueeze(torch.select(_87, 1, 0), 1)
  _88 = torch.slice(proposals, 0, 0, 9223372036854775807, 1)
  proposals_y1 = torch.unsqueeze(torch.select(_88, 1, 1), 1)
  _89 = torch.slice(proposals, 0, 0, 9223372036854775807, 1)
  proposals_x2 = torch.unsqueeze(torch.select(_89, 1, 2), 1)
  _90 = torch.slice(proposals, 0, 0, 9223372036854775807, 1)
  proposals_y2 = torch.unsqueeze(torch.select(_90, 1, 3), 1)
  _91 = torch.slice(reference_boxes, 0, 0, 9223372036854775807, 1)
  reference_boxes_x1 = torch.unsqueeze(torch.select(_91, 1, 0), 1)
  _92 = torch.slice(reference_boxes, 0, 0, 9223372036854775807, 1)
  reference_boxes_y1 = torch.unsqueeze(torch.select(_92, 1, 1), 1)
  _93 = torch.slice(reference_boxes, 0, 0, 9223372036854775807, 1)
  reference_boxes_x2 = torch.unsqueeze(torch.select(_93, 1, 2), 1)
  _94 = torch.slice(reference_boxes, 0, 0, 9223372036854775807, 1)
  reference_boxes_y2 = torch.unsqueeze(torch.select(_94, 1, 3), 1)
  ex_widths = torch.sub(proposals_x2, proposals_x1, alpha=1)
  ex_heights = torch.sub(proposals_y2, proposals_y1, alpha=1)
  ex_ctr_x = torch.add(proposals_x1, torch.mul(ex_widths, 0.5), alpha=1)
  ex_ctr_y = torch.add(proposals_y1, torch.mul(ex_heights, 0.5), alpha=1)
  gt_widths = torch.sub(reference_boxes_x2, reference_boxes_x1, alpha=1)
  gt_heights = torch.sub(reference_boxes_y2, reference_boxes_y1, alpha=1)
  gt_ctr_x = torch.add(reference_boxes_x1, torch.mul(gt_widths, 0.5), alpha=1)
  gt_ctr_y = torch.add(reference_boxes_y1, torch.mul(gt_heights, 0.5), alpha=1)
  _95 = torch.sub(gt_ctr_x, ex_ctr_x, alpha=1)
  targets_dx = torch.div(torch.mul(wx, _95), ex_widths)
  _96 = torch.sub(gt_ctr_y, ex_ctr_y, alpha=1)
  targets_dy = torch.div(torch.mul(wy, _96), ex_heights)
  _97 = torch.log(torch.div(gt_widths, ex_widths))
  targets_dw = torch.mul(ww, _97)
  _98 = torch.log(torch.div(gt_heights, ex_heights))
  targets_dh = torch.mul(wh, _98)
  _99 = [targets_dx, targets_dy, targets_dw, targets_dh]
  return torch.cat(_99, 1)
