class AnchorGenerator(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : None
  sizes : Tuple[Tuple[int], Tuple[int], Tuple[int], Tuple[int], Tuple[int]]
  aspect_ratios : Tuple[Tuple[float, float, float], Tuple[float, float, float], Tuple[float, float, float], Tuple[float, float, float], Tuple[float, float, float]]
  cell_anchors : Optional[List[Tensor]]
  _cache : Dict[str, List[Tensor]]
  def forward(self: __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator,
    image_list: __torch__.torchvision.models.detection.image_list.ImageList,
    feature_maps: List[Tensor]) -> List[Tensor]:
    _0 = annotate(List[List[int]], [])
    for _1 in range(torch.len(feature_maps)):
      feature_map = feature_maps[_1]
      _2 = torch.slice(torch.size(feature_map), -2, 9223372036854775807, 1)
      _3 = torch.append(_0, _2)
    grid_sizes = torch.list(_0)
    image_size = torch.slice(torch.size(image_list.tensors), -2, 9223372036854775807, 1)
    dtype = ops.prim.dtype(feature_maps[0])
    device = ops.prim.device(feature_maps[0])
    strides = annotate(List[List[Tensor]], [])
    for _4 in range(torch.len(grid_sizes)):
      g = grid_sizes[_4]
      _5 = torch.floordiv(image_size[0], g[0])
      _6 = torch.tensor(_5, dtype=4, device=device, requires_grad=False)
      _7 = torch.floordiv(image_size[1], g[1])
      _8 = torch.tensor(_7, dtype=4, device=device, requires_grad=False)
      _9 = torch.append(strides, [_6, _8])
    _10 = (self).set_cell_anchors(dtype, device, )
    anchors_over_all_feature_maps = (self).cached_grid_anchors(grid_sizes, strides, )
    anchors = annotate(List[List[Tensor]], [])
    for i in range(torch.len(image_list.image_sizes)):
      anchors_in_image = annotate(List[Tensor], [])
      _11 = torch.len(anchors_over_all_feature_maps)
      for _12 in range(_11):
        anchors_per_feature_map = anchors_over_all_feature_maps[_12]
        _13 = torch.append(anchors_in_image, anchors_per_feature_map)
      _14 = torch.append(anchors, anchors_in_image)
    anchors0 = annotate(List[Tensor], [])
    for _15 in range(torch.len(anchors)):
      anchors_per_image = anchors[_15]
      _16 = torch.append(anchors0, torch.cat(anchors_per_image, 0))
    torch.clear(self._cache)
    return anchors0
  def set_cell_anchors(self: __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator,
    dtype: int,
    device: Device) -> None:
    _17 = uninitialized(None)
    _18 = uninitialized(List[Tensor])
    _19 = torch.__isnot__(self.cell_anchors, None)
    if _19:
      cell_anchors = self.cell_anchors
      _22 = torch.__isnot__(cell_anchors, None)
      if _22:
        cell_anchors1 = unchecked_cast(List[Tensor], cell_anchors)
        cell_anchors0 = cell_anchors1
      else:
        ops.prim.RaiseException("AssertionError: ")
        cell_anchors0 = _18
      _23 = torch.eq(ops.prim.device(cell_anchors0[0]), device)
      if _23:
        _24, _25 = True, None
      else:
        _24, _25 = False, _17
      _20, _21 = _24, _25
    else:
      _20, _21 = False, _17
    if _20:
      _26 = _21
    else:
      cell_anchors2 = annotate(List[Tensor], [])
      sizes, sizes0, sizes1, sizes2, sizes3, = self.sizes
      aspect_ratios, aspect_ratios0, aspect_ratios1, aspect_ratios2, aspect_ratios3, = self.aspect_ratios
      _27, = sizes
      _28 = [_27]
      _29, _30, _31, = aspect_ratios
      _32 = (self).generate_anchors(_28, [_29, _30, _31], dtype, device, )
      _33 = torch.append(cell_anchors2, _32)
      _34, = sizes0
      _35 = [_34]
      _36, _37, _38, = aspect_ratios0
      _39 = (self).generate_anchors(_35, [_36, _37, _38], dtype, device, )
      _40 = torch.append(cell_anchors2, _39)
      _41, = sizes1
      _42 = [_41]
      _43, _44, _45, = aspect_ratios1
      _46 = (self).generate_anchors(_42, [_43, _44, _45], dtype, device, )
      _47 = torch.append(cell_anchors2, _46)
      _48, = sizes2
      _49 = [_48]
      _50, _51, _52, = aspect_ratios2
      _53 = (self).generate_anchors(_49, [_50, _51, _52], dtype, device, )
      _54 = torch.append(cell_anchors2, _53)
      _55, = sizes3
      _56 = [_55]
      _57, _58, _59, = aspect_ratios3
      _60 = (self).generate_anchors(_56, [_57, _58, _59], dtype, device, )
      _61 = torch.append(cell_anchors2, _60)
      self.cell_anchors = cell_anchors2
      _26 = None
    return _26
  def generate_anchors(self: __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator,
    scales: List[int],
    aspect_ratios: List[float],
    dtype: int=6,
    device: Device=torch.device("cpu")) -> Tensor:
    scales0 = torch.as_tensor(scales, dtype=dtype, device=device)
    aspect_ratios4 = torch.as_tensor(aspect_ratios, dtype=dtype, device=device)
    h_ratios = torch.sqrt(aspect_ratios4)
    w_ratios = torch.mul(torch.reciprocal(h_ratios), 1)
    _62 = torch.slice(w_ratios, 0, 0, 9223372036854775807, 1)
    _63 = torch.unsqueeze(_62, 1)
    _64 = torch.slice(torch.unsqueeze(scales0, 0), 1, 0, 9223372036854775807, 1)
    ws = torch.view(torch.mul(_63, _64), [-1])
    _65 = torch.slice(h_ratios, 0, 0, 9223372036854775807, 1)
    _66 = torch.unsqueeze(_65, 1)
    _67 = torch.slice(torch.unsqueeze(scales0, 0), 1, 0, 9223372036854775807, 1)
    hs = torch.view(torch.mul(_66, _67), [-1])
    _68 = [torch.neg(ws), torch.neg(hs), ws, hs]
    base_anchors = torch.div(torch.stack(_68, 1), 2)
    return torch.round(base_anchors)
  def cached_grid_anchors(self: __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator,
    grid_sizes: List[List[int]],
    strides: List[List[Tensor]]) -> List[Tensor]:
    key = torch.add(str(grid_sizes), str(strides))
    _69 = torch.__contains__(self._cache, key)
    if _69:
      _70 = (self._cache)[key]
    else:
      anchors = (self).grid_anchors(grid_sizes, strides, )
      torch._set_item(self._cache, key, anchors)
      _70 = anchors
    return _70
  def grid_anchors(self: __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator,
    grid_sizes: List[List[int]],
    strides: List[List[Tensor]]) -> List[Tensor]:
    _71 = "Anchors should be Tuple[Tuple[int]] because each feature map could potentially have different sizes and aspect ratios. There needs to be a match between the number of feature maps passed and the number of sizes / aspect ratios specified."
    _72 = uninitialized(List[Tensor])
    anchors = annotate(List[Tensor], [])
    cell_anchors = self.cell_anchors
    if torch.__isnot__(cell_anchors, None):
      cell_anchors4 = unchecked_cast(List[Tensor], cell_anchors)
      cell_anchors3 = cell_anchors4
    else:
      ops.prim.RaiseException("AssertionError: ")
      cell_anchors3 = _72
    _73 = torch.eq(torch.len(grid_sizes), torch.len(strides))
    if _73:
      _75 = torch.eq(torch.len(strides), torch.len(cell_anchors3))
      _74 = _75
    else:
      _74 = False
    if torch.__not__(_74):
      ops.prim.RaiseException(_71)
    else:
      pass
    _76 = [torch.len(grid_sizes), torch.len(strides), torch.len(cell_anchors3)]
    for _77 in range(ops.prim.min(_76)):
      size = grid_sizes[_77]
      stride = strides[_77]
      base_anchors = cell_anchors3[_77]
      grid_height, grid_width, = size
      stride_height, stride_width, = stride
      device = ops.prim.device(base_anchors)
      _78 = torch.arange(0, grid_width, dtype=6, layout=None, device=device, pin_memory=None)
      shifts_x = torch.mul(_78, stride_width)
      _79 = torch.arange(0, grid_height, dtype=6, layout=None, device=device, pin_memory=None)
      shifts_y = torch.mul(_79, stride_height)
      _80 = torch.meshgrid([shifts_y, shifts_x])
      shift_y, shift_x, = _80
      shift_x0 = torch.reshape(shift_x, [-1])
      shift_y0 = torch.reshape(shift_y, [-1])
      _81 = [shift_x0, shift_y0, shift_x0, shift_y0]
      shifts = torch.stack(_81, 1)
      _82 = torch.view(shifts, [-1, 1, 4])
      _83 = torch.view(base_anchors, [1, -1, 4])
      _84 = torch.reshape(torch.add(_82, _83, alpha=1), [-1, 4])
      _85 = torch.append(anchors, _84)
    return anchors
