class FasterRCNN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  _has_warned : bool
  transform : __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform
  backbone : __torch__.torchvision.models.detection.backbone_utils.BackboneWithFPN
  rpn : __torch__.torchvision.models.detection.rpn.RegionProposalNetwork
  roi_heads : __torch__.torchvision.models.detection.roi_heads.RoIHeads
  def forward(self: __torch__.torchvision.models.detection.faster_rcnn.FasterRCNN,
    images: List[Tensor],
    targets: Optional[List[Dict[str, Tensor]]]=None) -> Tuple[Dict[str, Tensor], List[Dict[str, Tensor]]]:
    _0 = "In training mode, targets should be passed"
    _1 = "Expected target boxes to be a tensorof shape [N, 4], got {:}."
    _2 = "All bounding boxes should have positive height and width. Found invalid box {} for target at index {}."
    _3 = "RCNN always returns a (Losses, Detections) tuple in scripting"
    _4 = uninitialized(List[Dict[str, Tensor]])
    if self.training:
      _5 = torch.__is__(targets, None)
    else:
      _5 = False
    if _5:
      ops.prim.RaiseException(_0)
    else:
      pass
    if self.training:
      if torch.__isnot__(targets, None):
        targets2 = unchecked_cast(List[Dict[str, Tensor]], targets)
        targets1 = targets2
      else:
        ops.prim.RaiseException("AssertionError: ")
        targets1 = _4
      for _6 in range(torch.len(targets1)):
        target = targets1[_6]
        boxes = target["boxes"]
        boxes0 = unchecked_cast(Tensor, boxes)
        _7 = torch.ne(torch.len(torch.size(boxes0)), 2)
        if _7:
          _8 = True
        else:
          _9 = torch.ne((torch.size(boxes0))[-1], 4)
          _8 = _9
        if _8:
          _10 = torch.format(_1, torch.size(boxes0))
          ops.prim.RaiseException(_10)
        else:
          pass
      targets0 = targets1
    else:
      targets0 = targets
    original_image_sizes = annotate(List[Tuple[int, int]], [])
    for _11 in range(torch.len(images)):
      img = images[_11]
      val = torch.slice(torch.size(img), -2, 9223372036854775807, 1)
      if torch.eq(torch.len(val), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _12 = torch.append(original_image_sizes, (val[0], val[1]))
    _13 = (self.transform).forward(images, targets0, )
    images0, targets3, = _13
    if torch.__isnot__(targets3, None):
      targets5 = unchecked_cast(List[Dict[str, Tensor]], targets3)
      _14 = [9223372036854775807, torch.len(targets5)]
      for target_idx in range(ops.prim.min(_14)):
        target0 = targets5[target_idx]
        boxes1 = target0["boxes"]
        _15 = torch.slice(boxes1, 0, 0, 9223372036854775807, 1)
        _16 = torch.slice(_15, 1, 2, 9223372036854775807, 1)
        _17 = torch.slice(boxes1, 0, 0, 9223372036854775807, 1)
        degenerate_boxes = torch.le(_16, torch.slice(_17, 1, 0, 2, 1))
        _18 = bool(torch.any(degenerate_boxes))
        if _18:
          _19 = torch.any(degenerate_boxes, 1, False)
          bb_idx = torch.select((torch.where(_19))[0], 0, 0)
          _20 = annotate(List[Optional[Tensor]], [bb_idx])
          degen_bb = annotate(List[float], torch.index(boxes1, _20).tolist())
          _21 = torch.format(_2, degen_bb, target_idx)
          ops.prim.RaiseException(_21)
        else:
          pass
      targets4 = targets5
    else:
      targets4 = targets3
    features = (self.backbone).forward(images0.tensors, )
    _22 = (self.rpn).forward(images0, features, targets4, )
    proposals, proposal_losses, = _22
    _23 = (self.roi_heads).forward(features, proposals, images0.image_sizes, targets4, )
    detections, detector_losses, = _23
    detections0 = (self.transform).postprocess(detections, images0.image_sizes, original_image_sizes, )
    losses = annotate(Dict[str, Tensor], {})
    torch.update(losses, detector_losses)
    torch.update(losses, proposal_losses)
    if torch.__not__(self._has_warned):
      torch.warn(_3, 2)
      self._has_warned = True
    else:
      pass
    return (losses, detections0)
class TwoMLPHead(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  fc6 : __torch__.torch.nn.modules.linear.Linear
  fc7 : __torch__.torch.nn.modules.linear.___torch_mangle_74.Linear
  def forward(self: __torch__.torchvision.models.detection.faster_rcnn.TwoMLPHead,
    x: Tensor) -> Tensor:
    x0 = torch.flatten(x, 1, -1)
    x1 = __torch__.torch.nn.functional.relu((self.fc6).forward(x0, ), False, )
    x2 = __torch__.torch.nn.functional.relu((self.fc7).forward(x1, ), False, )
    return x2
class FastRCNNPredictor(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  cls_score : __torch__.torch.nn.modules.linear.___torch_mangle_75.Linear
  bbox_pred : __torch__.torch.nn.modules.linear.___torch_mangle_76.Linear
  def forward(self: __torch__.torchvision.models.detection.faster_rcnn.FastRCNNPredictor,
    x: Tensor) -> Tuple[Tensor, Tensor]:
    if torch.eq(torch.dim(x), 4):
      _24 = torch.slice(torch.size(x), 2, 9223372036854775807, 1)
      if torch.eq(torch.list(_24), [1, 1]):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    x3 = torch.flatten(x, 1, -1)
    scores = (self.cls_score).forward(x3, )
    bbox_deltas = (self.bbox_pred).forward(x3, )
    return (scores, bbox_deltas)
