class RoIHeads(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : None
  proposal_matcher : __torch__.torchvision.models.detection._utils.Matcher
  fg_bg_sampler : __torch__.torchvision.models.detection._utils.BalancedPositiveNegativeSampler
  box_coder : __torch__.torchvision.models.detection._utils.BoxCoder
  score_thresh : float
  nms_thresh : float
  detections_per_img : int
  mask_roi_pool : None
  mask_head : None
  mask_predictor : None
  keypoint_roi_pool : None
  keypoint_head : None
  keypoint_predictor : None
  box_roi_pool : __torch__.torchvision.ops.poolers.MultiScaleRoIAlign
  box_head : __torch__.torchvision.models.detection.faster_rcnn.TwoMLPHead
  box_predictor : __torch__.torchvision.models.detection.faster_rcnn.FastRCNNPredictor
  def forward(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    features: Dict[str, Tensor],
    proposals: List[Tensor],
    image_shapes: List[Tuple[int, int]],
    targets: Optional[List[Dict[str, Tensor]]]=None) -> Tuple[List[Dict[str, Tensor]], Dict[str, Tensor]]:
    _0 = "AssertionError: target boxes must of float type"
    _1 = "AssertionError: target labels must of int64 type"
    _2 = "AssertionError: target keypoints must of float type"
    _3 = __torch__.torchvision.models.detection.roi_heads.fastrcnn_loss
    _4 = "Expected mask_roi_pool to be not None"
    _5 = uninitialized(List[Tensor])
    _6 = uninitialized(List[Tensor])
    if torch.__isnot__(targets, None):
      targets1 = unchecked_cast(List[Dict[str, Tensor]], targets)
      for _7 in range(torch.len(targets1)):
        t = targets1[_7]
        _8 = ops.prim.dtype(t["boxes"])
        _9 = torch.__contains__([6, 7, 5], _8)
        if _9:
          pass
        else:
          ops.prim.RaiseException(_0)
        _10 = torch.eq(ops.prim.dtype(t["labels"]), 4)
        if _10:
          pass
        else:
          ops.prim.RaiseException(_1)
        if (self).has_keypoint():
          _11 = ops.prim.dtype(t["keypoints"])
          if torch.eq(_11, 6):
            pass
          else:
            ops.prim.RaiseException(_2)
        else:
          pass
      targets0 = targets1
    else:
      targets0 = targets
    if self.training:
      _12 = (self).select_training_samples(proposals, targets0, )
      proposals1, matched_idxs0, labels0, regression_targets0, = _12
      proposals0, labels, regression_targets, matched_idxs = proposals1, labels0, regression_targets0, matched_idxs0
    else:
      proposals0, labels, regression_targets, matched_idxs = proposals, None, None, None
    box_features = (self.box_roi_pool).forward(features, proposals0, image_shapes, )
    box_features0 = (self.box_head).forward(box_features, )
    _13 = (self.box_predictor).forward(box_features0, )
    class_logits, box_regression, = _13
    result = annotate(List[Dict[str, Tensor]], [])
    losses = annotate(Dict[str, Tensor], {})
    if self.training:
      if torch.__isnot__(labels, None):
        labels2 = unchecked_cast(List[Tensor], labels)
        _15 = torch.__isnot__(regression_targets, None)
        _14, labels1 = _15, labels2
      else:
        _14, labels1 = False, labels
      if _14:
        labels4 = unchecked_cast(List[Tensor], labels1)
        regression_targets2 = unchecked_cast(List[Tensor], regression_targets)
        labels3, regression_targets1 = labels4, regression_targets2
      else:
        ops.prim.RaiseException("AssertionError: ")
        labels3, regression_targets1 = _5, _6
      _16 = _3(class_logits, box_regression, labels3, regression_targets1, )
      loss_classifier, loss_box_reg, = _16
      losses1 = {"loss_classifier": loss_classifier, "loss_box_reg": loss_box_reg}
      losses0 = losses1
    else:
      _17 = (self).postprocess_detections(class_logits, box_regression, proposals0, image_shapes, )
      boxes, scores, labels5, = _17
      num_images = torch.len(boxes)
      for i in range(num_images):
        _18 = {"boxes": boxes[i], "labels": labels5[i], "scores": scores[i]}
        _19 = torch.append(result, _18)
      losses0 = losses
    if (self).has_mask():
      if self.training:
        _20 = torch.__isnot__(matched_idxs, None)
        if _20:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      ops.prim.RaiseException(_4)
    else:
      pass
    return (result, losses0)
  def has_keypoint(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads) -> bool:
    return False
  def select_training_samples(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    proposals: List[Tensor],
    targets: Optional[List[Dict[str, Tensor]]]) -> Tuple[List[Tensor], List[Tensor], List[Tensor], List[Tensor]]:
    _21 = uninitialized(List[Dict[str, Tensor]])
    _22 = (self).check_targets(targets, )
    if torch.__isnot__(targets, None):
      targets3 = unchecked_cast(List[Dict[str, Tensor]], targets)
      targets2 = targets3
    else:
      ops.prim.RaiseException("AssertionError: ")
      targets2 = _21
    dtype = ops.prim.dtype(proposals[0])
    device = ops.prim.device(proposals[0])
    gt_boxes = annotate(List[Tensor], [])
    for _23 in range(torch.len(targets2)):
      t = targets2[_23]
      _24 = torch.to(t["boxes"], dtype, False, False, None)
      _25 = torch.append(gt_boxes, _24)
    gt_labels = annotate(List[Tensor], [])
    for _26 in range(torch.len(targets2)):
      t0 = targets2[_26]
      _27 = torch.append(gt_labels, t0["labels"])
    proposals2 = (self).add_gt_proposals(proposals, gt_boxes, )
    _28 = (self).assign_targets_to_proposals(proposals2, gt_boxes, gt_labels, )
    matched_idxs, labels, = _28
    sampled_inds = (self).subsample(labels, )
    matched_gt_boxes = annotate(List[Tensor], [])
    num_images = torch.len(proposals2)
    for img_id in range(num_images):
      img_sampled_inds = sampled_inds[img_id]
      _29 = proposals2[img_id]
      _30 = annotate(List[Optional[Tensor]], [img_sampled_inds])
      _31 = torch._set_item(proposals2, img_id, torch.index(_29, _30))
      _32 = labels[img_id]
      _33 = annotate(List[Optional[Tensor]], [img_sampled_inds])
      _34 = torch._set_item(labels, img_id, torch.index(_32, _33))
      _35 = matched_idxs[img_id]
      _36 = annotate(List[Optional[Tensor]], [img_sampled_inds])
      _37 = torch._set_item(matched_idxs, img_id, torch.index(_35, _36))
      gt_boxes_in_image = gt_boxes[img_id]
      _38 = torch.eq(torch.numel(gt_boxes_in_image), 0)
      if _38:
        gt_boxes_in_image1 = torch.zeros([1, 4], dtype=dtype, layout=None, device=device, pin_memory=None)
        gt_boxes_in_image0 = gt_boxes_in_image1
      else:
        gt_boxes_in_image0 = gt_boxes_in_image
      _39 = annotate(List[Optional[Tensor]], [matched_idxs[img_id]])
      _40 = torch.index(gt_boxes_in_image0, _39)
      _41 = torch.append(matched_gt_boxes, _40)
    regression_targets = (self.box_coder).encode(matched_gt_boxes, proposals2, )
    _42 = (proposals2, matched_idxs, labels, regression_targets)
    return _42
  def check_targets(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    targets: Optional[List[Dict[str, Tensor]]]) -> None:
    _43 = uninitialized(List[Dict[str, Tensor]])
    if torch.__isnot__(targets, None):
      targets5 = unchecked_cast(List[Dict[str, Tensor]], targets)
      targets4 = targets5
    else:
      ops.prim.RaiseException("AssertionError: ")
      targets4 = _43
    _44 = annotate(List[bool], [])
    for _45 in range(torch.len(targets4)):
      t = targets4[_45]
      _46 = torch.append(_44, torch.__contains__(t, "boxes"))
    if torch.all(_44):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _47 = annotate(List[bool], [])
    for _48 in range(torch.len(targets4)):
      t1 = targets4[_48]
      _49 = torch.append(_47, torch.__contains__(t1, "labels"))
    if torch.all(_47):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if (self).has_mask():
      _50 = annotate(List[bool], [])
      for _51 in range(torch.len(targets4)):
        t2 = targets4[_51]
        _52 = torch.append(_50, torch.__contains__(t2, "masks"))
      if torch.all(_50):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    return None
  def has_mask(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads) -> bool:
    return False
  def add_gt_proposals(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    proposals: List[Tensor],
    gt_boxes: List[Tensor]) -> List[Tensor]:
    proposals3 = annotate(List[Tensor], [])
    _53 = [torch.len(proposals), torch.len(gt_boxes)]
    for _54 in range(ops.prim.min(_53)):
      proposal = proposals[_54]
      gt_box = gt_boxes[_54]
      _55 = torch.append(proposals3, torch.cat([proposal, gt_box], 0))
    return proposals3
  def assign_targets_to_proposals(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    proposals: List[Tensor],
    gt_boxes: List[Tensor],
    gt_labels: List[Tensor]) -> Tuple[List[Tensor], List[Tensor]]:
    _56 = __torch__.torchvision.ops.boxes.box_iou
    matched_idxs = annotate(List[Tensor], [])
    labels = annotate(List[Tensor], [])
    _57 = [torch.len(proposals), torch.len(gt_boxes), torch.len(gt_labels)]
    for _58 in range(ops.prim.min(_57)):
      proposals_in_image = proposals[_58]
      gt_boxes_in_image = gt_boxes[_58]
      gt_labels_in_image = gt_labels[_58]
      _59 = torch.eq(torch.numel(gt_boxes_in_image), 0)
      if _59:
        device = ops.prim.device(proposals_in_image)
        _60 = (torch.size(proposals_in_image))[0]
        clamped_matched_idxs_in_image0 = torch.zeros([_60], dtype=4, layout=None, device=device, pin_memory=None)
        _61 = (torch.size(proposals_in_image))[0]
        labels_in_image0 = torch.zeros([_61], dtype=4, layout=None, device=device, pin_memory=None)
        clamped_matched_idxs_in_image, labels_in_image = clamped_matched_idxs_in_image0, labels_in_image0
      else:
        match_quality_matrix = _56(gt_boxes_in_image, proposals_in_image, )
        matched_idxs_in_image = (self.proposal_matcher).__call__(match_quality_matrix, )
        clamped_matched_idxs_in_image1 = torch.clamp(matched_idxs_in_image, 0, None)
        _62 = annotate(List[Optional[Tensor]], [clamped_matched_idxs_in_image1])
        labels_in_image1 = torch.index(gt_labels_in_image, _62)
        labels_in_image2 = torch.to(labels_in_image1, 4, False, False, None)
        _63 = self.proposal_matcher.BELOW_LOW_THRESHOLD
        bg_inds = torch.eq(matched_idxs_in_image, _63)
        _64 = ops.prim.dtype(labels_in_image2)
        _65 = ops.prim.device(labels_in_image2)
        _66 = torch.tensor(0, dtype=_64, device=_65, requires_grad=False)
        _67 = annotate(List[Optional[Tensor]], [bg_inds])
        _68 = torch.index_put_(labels_in_image2, _67, _66, False)
        _69 = self.proposal_matcher.BETWEEN_THRESHOLDS
        ignore_inds = torch.eq(matched_idxs_in_image, _69)
        _70 = ops.prim.dtype(labels_in_image2)
        _71 = ops.prim.device(labels_in_image2)
        _72 = torch.tensor(-1, dtype=_70, device=_71, requires_grad=False)
        _73 = annotate(List[Optional[Tensor]], [ignore_inds])
        _74 = torch.index_put_(labels_in_image2, _73, _72, False)
        clamped_matched_idxs_in_image, labels_in_image = clamped_matched_idxs_in_image1, labels_in_image2
      _75 = torch.append(matched_idxs, clamped_matched_idxs_in_image)
      _76 = torch.append(labels, labels_in_image)
    return (matched_idxs, labels)
  def subsample(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    labels: List[Tensor]) -> List[Tensor]:
    _77 = (self.fg_bg_sampler).__call__(labels, )
    sampled_pos_inds, sampled_neg_inds, = _77
    sampled_inds = annotate(List[Tensor], [])
    _78 = [9223372036854775807, torch.len(sampled_pos_inds), torch.len(sampled_neg_inds)]
    for img_idx in range(ops.prim.min(_78)):
      pos_inds_img = sampled_pos_inds[img_idx]
      neg_inds_img = sampled_neg_inds[img_idx]
      _79 = torch.__or__(pos_inds_img, neg_inds_img)
      img_sampled_inds = (torch.where(_79))[0]
      _80 = torch.append(sampled_inds, img_sampled_inds)
    return sampled_inds
  def postprocess_detections(self: __torch__.torchvision.models.detection.roi_heads.RoIHeads,
    class_logits: Tensor,
    box_regression: Tensor,
    proposals: List[Tensor],
    image_shapes: List[Tuple[int, int]]) -> Tuple[List[Tensor], List[Tensor], List[Tensor]]:
    _81 = __torch__.torch.nn.functional.softmax
    _82 = __torch__.torchvision.ops.boxes.clip_boxes_to_image
    _83 = __torch__.torchvision.ops.boxes.remove_small_boxes
    _84 = __torch__.torchvision.ops.boxes.batched_nms
    device = ops.prim.device(class_logits)
    num_classes = (torch.size(class_logits))[-1]
    boxes_per_image = annotate(List[int], [])
    for _85 in range(torch.len(proposals)):
      boxes_in_image = proposals[_85]
      _86 = torch.append(boxes_per_image, (torch.size(boxes_in_image))[0])
    pred_boxes = (self.box_coder).decode(box_regression, proposals, )
    pred_scores = _81(class_logits, -1, 3, None, )
    pred_boxes_list = torch.split(pred_boxes, boxes_per_image, 0)
    pred_scores_list = torch.split(pred_scores, boxes_per_image, 0)
    all_boxes = annotate(List[Tensor], [])
    all_scores = annotate(List[Tensor], [])
    all_labels = annotate(List[Tensor], [])
    _87 = [torch.len(pred_boxes_list), torch.len(pred_scores_list), torch.len(image_shapes)]
    for _88 in range(ops.prim.min(_87)):
      boxes = pred_boxes_list[_88]
      scores = pred_scores_list[_88]
      image_shape = image_shapes[_88]
      boxes0 = _82(boxes, image_shape, )
      labels = torch.arange(num_classes, dtype=None, layout=None, device=device, pin_memory=None)
      labels6 = torch.expand_as(torch.view(labels, [1, -1]), scores)
      _89 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
      boxes1 = torch.slice(_89, 1, 1, 9223372036854775807, 1)
      _90 = torch.slice(scores, 0, 0, 9223372036854775807, 1)
      scores0 = torch.slice(_90, 1, 1, 9223372036854775807, 1)
      _91 = torch.slice(labels6, 0, 0, 9223372036854775807, 1)
      labels7 = torch.slice(_91, 1, 1, 9223372036854775807, 1)
      boxes2 = torch.reshape(boxes1, [-1, 4])
      scores1 = torch.reshape(scores0, [-1])
      labels8 = torch.reshape(labels7, [-1])
      _92 = torch.gt(scores1, self.score_thresh)
      inds = (torch.where(_92))[0]
      _93 = annotate(List[Optional[Tensor]], [inds])
      boxes3 = torch.index(boxes2, _93)
      _94 = annotate(List[Optional[Tensor]], [inds])
      scores2 = torch.index(scores1, _94)
      _95 = annotate(List[Optional[Tensor]], [inds])
      labels9 = torch.index(labels8, _95)
      keep = _83(boxes3, 0.01, )
      _96 = annotate(List[Optional[Tensor]], [keep])
      boxes4 = torch.index(boxes3, _96)
      _97 = annotate(List[Optional[Tensor]], [keep])
      scores3 = torch.index(scores2, _97)
      _98 = annotate(List[Optional[Tensor]], [keep])
      labels10 = torch.index(labels9, _98)
      keep0 = _84(boxes4, scores3, labels10, self.nms_thresh, )
      keep1 = torch.slice(keep0, 0, 0, self.detections_per_img, 1)
      _99 = annotate(List[Optional[Tensor]], [keep1])
      boxes5 = torch.index(boxes4, _99)
      _100 = annotate(List[Optional[Tensor]], [keep1])
      scores4 = torch.index(scores3, _100)
      _101 = annotate(List[Optional[Tensor]], [keep1])
      labels11 = torch.index(labels10, _101)
      _102 = torch.append(all_boxes, boxes5)
      _103 = torch.append(all_scores, scores4)
      _104 = torch.append(all_labels, labels11)
    return (all_boxes, all_scores, all_labels)
def paste_masks_in_image(masks: Tensor,
    boxes: Tensor,
    img_shape: Tuple[int, int],
    padding: int=1) -> Tensor:
  _105 = __torch__.torchvision.models.detection.roi_heads.expand_masks
  _106 = __torch__.torchvision.models.detection.roi_heads.expand_boxes
  _107 = __torch__.torchvision.models.detection.roi_heads._onnx_paste_masks_in_image_loop
  _108 = __torch__.torchvision.models.detection.roi_heads.paste_mask_in_image
  masks0, scale, = _105(masks, padding, )
  boxes6 = torch.to(_106(boxes, scale, ), 4, False, False, None)
  im_h, im_w, = img_shape
  if __torch__.torchvision._is_tracing():
    _110 = torch.scalar_tensor(im_h, dtype=4, layout=None, device=None, pin_memory=None)
    _111 = torch.scalar_tensor(im_w, dtype=4, layout=None, device=None, pin_memory=None)
    _112 = torch.slice(_107(masks0, boxes6, _110, _111, ), 0, 0, 9223372036854775807, 1)
    _109 = torch.unsqueeze(_112, 1)
  else:
    res = annotate(List[Tensor], [])
    _113 = [torch.len(masks0), torch.len(boxes6)]
    for _114 in range(ops.prim.min(_113)):
      m = torch.select(masks0, 0, _114)
      b = torch.select(boxes6, 0, _114)
      _115 = _108(torch.select(m, 0, 0), b, im_h, im_w, )
      _116 = torch.append(res, _115)
    if torch.gt(torch.len(res), 0):
      _117 = torch.slice(torch.stack(res, 0), 0, 0, 9223372036854775807, 1)
      ret = torch.unsqueeze(_117, 1)
    else:
      ret0 = torch.new_empty(masks0, [0, 1, im_h, im_w], dtype=None, layout=None, device=None, pin_memory=None)
      ret = ret0
    _109 = ret
  return _109
def fastrcnn_loss(class_logits: Tensor,
    box_regression: Tensor,
    labels: List[Tensor],
    regression_targets: List[Tensor]) -> Tuple[Tensor, Tensor]:
  _118 = __torch__.torch.nn.functional.cross_entropy
  _119 = __torch__.torchvision.models.detection._utils.smooth_l1_loss
  labels12 = torch.cat(labels, 0)
  regression_targets3 = torch.cat(regression_targets, 0)
  classification_loss = _118(class_logits, labels12, None, None, -100, None, "mean", )
  sampled_pos_inds_subset = (torch.where(torch.gt(labels12, 0)))[0]
  _120 = annotate(List[Optional[Tensor]], [sampled_pos_inds_subset])
  labels_pos = torch.index(labels12, _120)
  N, num_classes, = torch.size(class_logits)
  _121 = torch.floordiv(torch.size(box_regression, -1), 4)
  box_regression0 = torch.reshape(box_regression, [N, _121, 4])
  _122 = annotate(List[Optional[Tensor]], [sampled_pos_inds_subset, labels_pos])
  _123 = torch.index(box_regression0, _122)
  _124 = annotate(List[Optional[Tensor]], [sampled_pos_inds_subset])
  _125 = torch.index(regression_targets3, _124)
  box_loss = _119(_123, _125, 0.1111111111111111, False, )
  box_loss0 = torch.div(box_loss, torch.numel(labels12))
  return (classification_loss, box_loss0)
def expand_masks(mask: Tensor,
    padding: int) -> Tuple[Tensor, float]:
  M = (torch.size(mask))[-1]
  _126 = float(torch.add(M, torch.mul(2, padding)))
  scale = torch.div(_126, M)
  padded_mask = __torch__.torch.nn.functional._pad(mask, torch.mul([padding], 4), "constant", 0., )
  return (padded_mask, scale)
def expand_boxes(boxes: Tensor,
    scale: float) -> Tensor:
  _127 = __torch__.torchvision.models.detection.roi_heads._onnx_expand_boxes
  if __torch__.torchvision._is_tracing():
    _128 = _127(boxes, scale, )
  else:
    _129 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _130 = torch.select(_129, 1, 2)
    _131 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _132 = torch.sub(_130, torch.select(_131, 1, 0), alpha=1)
    w_half = torch.mul(_132, 0.5)
    _133 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _134 = torch.select(_133, 1, 3)
    _135 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _136 = torch.sub(_134, torch.select(_135, 1, 1), alpha=1)
    h_half = torch.mul(_136, 0.5)
    _137 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _138 = torch.select(_137, 1, 2)
    _139 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _140 = torch.add(_138, torch.select(_139, 1, 0), alpha=1)
    x_c = torch.mul(_140, 0.5)
    _141 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _142 = torch.select(_141, 1, 3)
    _143 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
    _144 = torch.add(_142, torch.select(_143, 1, 1), alpha=1)
    y_c = torch.mul(_144, 0.5)
    w_half0 = torch.mul_(w_half, scale)
    h_half0 = torch.mul_(h_half, scale)
    boxes_exp = torch.zeros_like(boxes, dtype=None, layout=None, device=None, pin_memory=None, memory_format=None)
    _145 = torch.sub(x_c, w_half0, alpha=1)
    _146 = torch.slice(boxes_exp, 0, 0, 9223372036854775807, 1)
    _147 = torch.copy_(torch.select(_146, 1, 0), _145, False)
    _148 = torch.add(x_c, w_half0, alpha=1)
    _149 = torch.slice(boxes_exp, 0, 0, 9223372036854775807, 1)
    _150 = torch.copy_(torch.select(_149, 1, 2), _148, False)
    _151 = torch.sub(y_c, h_half0, alpha=1)
    _152 = torch.slice(boxes_exp, 0, 0, 9223372036854775807, 1)
    _153 = torch.copy_(torch.select(_152, 1, 1), _151, False)
    _154 = torch.add(y_c, h_half0, alpha=1)
    _155 = torch.slice(boxes_exp, 0, 0, 9223372036854775807, 1)
    _156 = torch.copy_(torch.select(_155, 1, 3), _154, False)
    _128 = boxes_exp
  return _128
def _onnx_paste_masks_in_image_loop(masks: Tensor,
    boxes: Tensor,
    im_h: Tensor,
    im_w: Tensor) -> Tensor:
  _157 = __torch__.torchvision.models.detection.roi_heads._onnx_paste_mask_in_image
  _158 = [0, annotate(int, im_h), annotate(int, im_w)]
  res_append = torch.zeros(_158, dtype=None, layout=None, device=None, pin_memory=None)
  res_append0 = res_append
  for i in range(torch.size(masks, 0)):
    _159 = torch.select(torch.select(masks, 0, i), 0, 0)
    mask_res = _157(_159, torch.select(boxes, 0, i), im_h, im_w, )
    mask_res0 = torch.unsqueeze(mask_res, 0)
    res_append1 = torch.cat([res_append0, mask_res0], 0)
    res_append0 = res_append1
  return res_append0
def paste_mask_in_image(mask: Tensor,
    box: Tensor,
    im_h: int,
    im_w: int) -> Tensor:
  _160 = __torch__.torch.nn.functional.___torch_mangle_77.interpolate
  _161 = torch.sub(torch.select(box, 0, 2), torch.select(box, 0, 0), alpha=1)
  w = int(torch.add(_161, 1, 1))
  _162 = torch.sub(torch.select(box, 0, 3), torch.select(box, 0, 1), alpha=1)
  h = int(torch.add(_162, 1, 1))
  w0 = ops.prim.max(w, 1)
  h0 = ops.prim.max(h, 1)
  mask0 = torch.expand(mask, [1, 1, -1, -1], implicit=False)
  mask1 = _160(mask0, [h0, w0], None, "bilinear", False, None, )
  mask2 = torch.select(torch.select(mask1, 0, 0), 0, 0)
  _163 = ops.prim.dtype(mask2)
  _164 = ops.prim.device(mask2)
  im_mask = torch.zeros([im_h, im_w], dtype=_163, layout=None, device=_164, pin_memory=None)
  _165 = annotate(int, torch.select(box, 0, 0))
  x_0 = ops.prim.max(_165, 0)
  _166 = torch.add(torch.select(box, 0, 2), 1, 1)
  x_1 = ops.prim.min(annotate(int, _166), im_w)
  _167 = annotate(int, torch.select(box, 0, 1))
  y_0 = ops.prim.max(_167, 0)
  _168 = torch.add(torch.select(box, 0, 3), 1, 1)
  y_1 = ops.prim.min(annotate(int, _168), im_h)
  _169 = torch.add(torch.neg(torch.select(box, 0, 1)), y_0, 1)
  _170 = torch.add(torch.neg(torch.select(box, 0, 1)), y_1, 1)
  _171 = torch.slice(mask2, 0, annotate(int, _169), annotate(int, _170), 1)
  _172 = torch.add(torch.neg(torch.select(box, 0, 0)), x_0, 1)
  _173 = torch.add(torch.neg(torch.select(box, 0, 0)), x_1, 1)
  _174 = torch.slice(_171, 1, annotate(int, _172), annotate(int, _173), 1)
  _175 = torch.slice(torch.slice(im_mask, 0, y_0, y_1, 1), 1, x_0, x_1, 1)
  _176 = torch.copy_(_175, _174, False)
  return im_mask
def _onnx_expand_boxes(boxes: Tensor,
    scale: float) -> Tensor:
  _177 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _178 = torch.select(_177, 1, 2)
  _179 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _180 = torch.sub(_178, torch.select(_179, 1, 0), alpha=1)
  w_half = torch.mul(_180, 0.5)
  _181 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _182 = torch.select(_181, 1, 3)
  _183 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _184 = torch.sub(_182, torch.select(_183, 1, 1), alpha=1)
  h_half = torch.mul(_184, 0.5)
  _185 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _186 = torch.select(_185, 1, 2)
  _187 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _188 = torch.add(_186, torch.select(_187, 1, 0), alpha=1)
  x_c = torch.mul(_188, 0.5)
  _189 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _190 = torch.select(_189, 1, 3)
  _191 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _192 = torch.add(_190, torch.select(_191, 1, 1), alpha=1)
  y_c = torch.mul(_192, 0.5)
  _193 = torch.to(w_half, 6, False, False, None)
  w_half1 = torch.mul(_193, scale)
  _194 = torch.to(h_half, 6, False, False, None)
  h_half1 = torch.mul(_194, scale)
  boxes_exp0 = torch.sub(x_c, w_half1, alpha=1)
  boxes_exp1 = torch.sub(y_c, h_half1, alpha=1)
  boxes_exp2 = torch.add(x_c, w_half1, alpha=1)
  boxes_exp3 = torch.add(y_c, h_half1, alpha=1)
  _195 = [boxes_exp0, boxes_exp1, boxes_exp2, boxes_exp3]
  return torch.stack(_195, 1)
def _onnx_paste_mask_in_image(mask: Tensor,
    box: Tensor,
    im_h: Tensor,
    im_w: Tensor) -> Tensor:
  _196 = __torch__.torch.nn.functional.___torch_mangle_77.interpolate
  one = torch.ones([1], dtype=4, layout=None, device=None, pin_memory=None)
  zero = torch.zeros([1], dtype=4, layout=None, device=None, pin_memory=None)
  _197 = torch.sub(torch.select(box, 0, 2), torch.select(box, 0, 0), alpha=1)
  w = torch.add(_197, one, alpha=1)
  _198 = torch.sub(torch.select(box, 0, 3), torch.select(box, 0, 1), alpha=1)
  h = torch.add(_198, one, alpha=1)
  w1 = torch.max(torch.cat([w, one], 0))
  h1 = torch.max(torch.cat([h, one], 0))
  _199 = [1, 1, torch.size(mask, 0), torch.size(mask, 1)]
  mask3 = torch.expand(mask, _199, implicit=False)
  mask4 = _196(mask3, [int(h1), int(w1)], None, "bilinear", False, None, )
  mask5 = torch.select(torch.select(mask4, 0, 0), 0, 0)
  _200 = torch.unsqueeze(torch.select(box, 0, 0), 0)
  x_0 = torch.max(torch.cat([_200, zero], 0))
  _201 = torch.unsqueeze(torch.select(box, 0, 2), 0)
  _202 = [torch.add(_201, one, alpha=1), torch.unsqueeze(im_w, 0)]
  x_1 = torch.min(torch.cat(_202, 0))
  _203 = torch.unsqueeze(torch.select(box, 0, 1), 0)
  y_0 = torch.max(torch.cat([_203, zero], 0))
  _204 = torch.unsqueeze(torch.select(box, 0, 3), 0)
  _205 = [torch.add(_204, one, alpha=1), torch.unsqueeze(im_h, 0)]
  y_1 = torch.min(torch.cat(_205, 0))
  _206 = torch.sub(y_0, torch.select(box, 0, 1), alpha=1)
  _207 = torch.sub(y_1, torch.select(box, 0, 1), alpha=1)
  _208 = torch.slice(mask5, 0, annotate(int, _206), annotate(int, _207), 1)
  _209 = torch.sub(x_0, torch.select(box, 0, 0), alpha=1)
  _210 = torch.sub(x_1, torch.select(box, 0, 0), alpha=1)
  unpaded_im_mask = torch.slice(_208, 1, annotate(int, _209), annotate(int, _210), 1)
  _211 = torch.size(unpaded_im_mask, 1)
  zeros_y0 = torch.zeros([annotate(int, y_0), _211], dtype=None, layout=None, device=None, pin_memory=None)
  _212 = torch.sub(im_h, y_1, alpha=1)
  _213 = torch.size(unpaded_im_mask, 1)
  zeros_y1 = torch.zeros([annotate(int, _212), _213], dtype=None, layout=None, device=None, pin_memory=None)
  _214 = torch.to(unpaded_im_mask, 6, False, False, None)
  _215 = torch.cat([zeros_y0, _214, zeros_y1], 0)
  _216 = torch.slice(_215, 0, 0, annotate(int, im_h), 1)
  concat_0 = torch.slice(_216, 1, 0, 9223372036854775807, 1)
  _217 = [torch.size(concat_0, 0), annotate(int, x_0)]
  zeros_x0 = torch.zeros(_217, dtype=None, layout=None, device=None, pin_memory=None)
  _218 = torch.size(concat_0, 0)
  _219 = annotate(int, torch.sub(im_w, x_1, alpha=1))
  zeros_x1 = torch.zeros([_218, _219], dtype=None, layout=None, device=None, pin_memory=None)
  _220 = torch.cat([zeros_x0, concat_0, zeros_x1], 1)
  _221 = torch.slice(_220, 0, 0, 9223372036854775807, 1)
  im_mask = torch.slice(_221, 1, 0, annotate(int, im_w), 1)
  return im_mask
