class RegionProposalNetwork(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : None
  box_coder : __torch__.torchvision.models.detection._utils.BoxCoder
  proposal_matcher : __torch__.torchvision.models.detection._utils.Matcher
  fg_bg_sampler : __torch__.torchvision.models.detection._utils.BalancedPositiveNegativeSampler
  _pre_nms_top_n : Dict[str, int]
  _post_nms_top_n : Dict[str, int]
  nms_thresh : float
  score_thresh : float
  min_size : float
  anchor_generator : __torch__.torchvision.models.detection.anchor_utils.AnchorGenerator
  head : __torch__.torchvision.models.detection.rpn.RPNHead
  def forward(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork,
    images: __torch__.torchvision.models.detection.image_list.ImageList,
    features: Dict[str, Tensor],
    targets: Optional[List[Dict[str, Tensor]]]=None) -> Tuple[List[Tensor], Dict[str, Tensor]]:
    _0 = __torch__.torchvision.models.detection.rpn.concat_box_prediction_layers
    _1 = uninitialized(List[Dict[str, Tensor]])
    features0 = torch.list(torch.values(features))
    objectness, pred_bbox_deltas, = (self.head).forward(features0, )
    anchors = (self.anchor_generator).forward(images, features0, )
    num_images = torch.len(anchors)
    num_anchors_per_level_shape_tensors = annotate(List[List[int]], [])
    for _2 in range(torch.len(objectness)):
      o = objectness[_2]
      _3 = torch.append(num_anchors_per_level_shape_tensors, torch.size(torch.select(o, 0, 0)))
    num_anchors_per_level = annotate(List[int], [])
    _4 = torch.len(num_anchors_per_level_shape_tensors)
    for _5 in range(_4):
      s = num_anchors_per_level_shape_tensors[_5]
      _6 = torch.mul(torch.mul(s[0], s[1]), s[2])
      _7 = torch.append(num_anchors_per_level, _6)
    objectness0, pred_bbox_deltas0, = _0(objectness, pred_bbox_deltas, )
    proposals = (self.box_coder).decode(torch.detach(pred_bbox_deltas0), anchors, )
    proposals0 = torch.view(proposals, [num_images, -1, 4])
    _8 = (self).filter_proposals(proposals0, objectness0, images.image_sizes, num_anchors_per_level, )
    boxes, scores, = _8
    losses = annotate(Dict[str, Tensor], {})
    if self.training:
      if torch.__isnot__(targets, None):
        targets1 = unchecked_cast(List[Dict[str, Tensor]], targets)
        targets0 = targets1
      else:
        ops.prim.RaiseException("AssertionError: ")
        targets0 = _1
      _9 = (self).assign_targets_to_anchors(anchors, targets0, )
      labels, matched_gt_boxes, = _9
      regression_targets = (self.box_coder).encode(matched_gt_boxes, anchors, )
      _10 = (self).compute_loss(objectness0, pred_bbox_deltas0, labels, regression_targets, )
      loss_objectness, loss_rpn_box_reg, = _10
      losses1 = {"loss_objectness": loss_objectness, "loss_rpn_box_reg": loss_rpn_box_reg}
      losses0 = losses1
    else:
      losses0 = losses
    return (boxes, losses0)
  def filter_proposals(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork,
    proposals: Tensor,
    objectness: Tensor,
    image_shapes: List[Tuple[int, int]],
    num_anchors_per_level: List[int]) -> Tuple[List[Tensor], List[Tensor]]:
    _11 = __torch__.torchvision.ops.boxes.clip_boxes_to_image
    _12 = __torch__.torchvision.ops.boxes.remove_small_boxes
    _13 = __torch__.torchvision.ops.boxes.batched_nms
    num_images = (torch.size(proposals))[0]
    device = ops.prim.device(proposals)
    objectness1 = torch.detach(objectness)
    objectness2 = torch.reshape(objectness1, [num_images, -1])
    levels = annotate(List[Tensor], [])
    _14 = [9223372036854775807, torch.len(num_anchors_per_level)]
    for idx in range(ops.prim.min(_14)):
      n = num_anchors_per_level[idx]
      _15 = torch.full([n], idx, dtype=4, layout=None, device=device, pin_memory=None)
      _16 = torch.append(levels, _15)
    levels0 = torch.cat(levels, 0)
    levels1 = torch.expand_as(torch.reshape(levels0, [1, -1]), objectness2)
    top_n_idx = (self)._get_top_n_idx(objectness2, num_anchors_per_level, )
    image_range = torch.arange(num_images, dtype=None, layout=None, device=device, pin_memory=None)
    _17 = torch.slice(image_range, 0, 0, 9223372036854775807, 1)
    batch_idx = torch.unsqueeze(_17, 1)
    _18 = annotate(List[Optional[Tensor]], [batch_idx, top_n_idx])
    objectness3 = torch.index(objectness2, _18)
    _19 = annotate(List[Optional[Tensor]], [batch_idx, top_n_idx])
    levels2 = torch.index(levels1, _19)
    _20 = annotate(List[Optional[Tensor]], [batch_idx, top_n_idx])
    proposals1 = torch.index(proposals, _20)
    objectness_prob = torch.sigmoid(objectness3)
    final_boxes = annotate(List[Tensor], [])
    final_scores = annotate(List[Tensor], [])
    _21 = [torch.len(proposals1), torch.len(objectness_prob), torch.len(levels2), torch.len(image_shapes)]
    for _22 in range(ops.prim.min(_21)):
      boxes = torch.select(proposals1, 0, _22)
      scores = torch.select(objectness_prob, 0, _22)
      lvl = torch.select(levels2, 0, _22)
      img_shape = image_shapes[_22]
      boxes0 = _11(boxes, img_shape, )
      keep = _12(boxes0, self.min_size, )
      _23 = annotate(List[Optional[Tensor]], [keep])
      boxes1 = torch.index(boxes0, _23)
      _24 = annotate(List[Optional[Tensor]], [keep])
      scores0 = torch.index(scores, _24)
      _25 = annotate(List[Optional[Tensor]], [keep])
      lvl0 = torch.index(lvl, _25)
      _26 = torch.ge(scores0, self.score_thresh)
      keep0 = (torch.where(_26))[0]
      _27 = annotate(List[Optional[Tensor]], [keep0])
      boxes2 = torch.index(boxes1, _27)
      _28 = annotate(List[Optional[Tensor]], [keep0])
      scores1 = torch.index(scores0, _28)
      _29 = annotate(List[Optional[Tensor]], [keep0])
      lvl1 = torch.index(lvl0, _29)
      keep1 = _13(boxes2, scores1, lvl1, self.nms_thresh, )
      keep2 = torch.slice(keep1, 0, 0, (self).post_nms_top_n(), 1)
      _30 = annotate(List[Optional[Tensor]], [keep2])
      boxes3 = torch.index(boxes2, _30)
      _31 = annotate(List[Optional[Tensor]], [keep2])
      scores2 = torch.index(scores1, _31)
      _32 = torch.append(final_boxes, boxes3)
      _33 = torch.append(final_scores, scores2)
    return (final_boxes, final_scores)
  def _get_top_n_idx(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork,
    objectness: Tensor,
    num_anchors_per_level: List[int]) -> Tensor:
    _34 = "This Python function is annotated to be ignored and cannot be run"
    _35 = uninitialized(int)
    r = annotate(List[Tensor], [])
    _36 = torch.split(objectness, num_anchors_per_level, 1)
    offset = 0
    for _37 in range(torch.len(_36)):
      ob = _36[_37]
      _38 = __torch__.torchvision._is_tracing()
      if _38:
        _39 = (self).pre_nms_top_n()
        ops.prim.RaiseException(_34)
        pre_nms_top_n, num_anchors = _35, _35
      else:
        num_anchors0 = (torch.size(ob))[1]
        pre_nms_top_n0 = ops.prim.min((self).pre_nms_top_n(), num_anchors0)
        pre_nms_top_n, num_anchors = pre_nms_top_n0, num_anchors0
      _40, top_n_idx = torch.topk(ob, pre_nms_top_n, 1, True, True)
      _41 = torch.append(r, torch.add(top_n_idx, offset, 1))
      offset = torch.add(offset, num_anchors)
    return torch.cat(r, 1)
  def pre_nms_top_n(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork) -> int:
    if self.training:
      _42 = (self._pre_nms_top_n)["training"]
    else:
      _42 = (self._pre_nms_top_n)["testing"]
    return _42
  def post_nms_top_n(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork) -> int:
    if self.training:
      _44 = (self._post_nms_top_n)["training"]
      _43 = _44
    else:
      _43 = (self._post_nms_top_n)["testing"]
    return _43
  def assign_targets_to_anchors(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork,
    anchors: List[Tensor],
    targets: List[Dict[str, Tensor]]) -> Tuple[List[Tensor], List[Tensor]]:
    _45 = __torch__.torchvision.ops.boxes.box_iou
    labels = annotate(List[Tensor], [])
    matched_gt_boxes = annotate(List[Tensor], [])
    _46 = [torch.len(anchors), torch.len(targets)]
    for _47 in range(ops.prim.min(_46)):
      anchors_per_image = anchors[_47]
      targets_per_image = targets[_47]
      gt_boxes = targets_per_image["boxes"]
      _48 = torch.eq(torch.numel(gt_boxes), 0)
      if _48:
        device = ops.prim.device(anchors_per_image)
        matched_gt_boxes_per_image0 = torch.zeros(torch.size(anchors_per_image), dtype=6, layout=None, device=device, pin_memory=None)
        _49 = (torch.size(anchors_per_image))[0]
        labels_per_image0 = torch.zeros([_49], dtype=6, layout=None, device=device, pin_memory=None)
        labels_per_image, matched_gt_boxes_per_image = labels_per_image0, matched_gt_boxes_per_image0
      else:
        match_quality_matrix = _45(gt_boxes, anchors_per_image, )
        matched_idxs = (self.proposal_matcher).__call__(match_quality_matrix, )
        _50 = torch.clamp(matched_idxs, 0, None)
        _51 = annotate(List[Optional[Tensor]], [_50])
        matched_gt_boxes_per_image1 = torch.index(gt_boxes, _51)
        labels_per_image1 = torch.ge(matched_idxs, 0)
        labels_per_image2 = torch.to(labels_per_image1, 6, False, False, None)
        _52 = self.proposal_matcher.BELOW_LOW_THRESHOLD
        bg_indices = torch.eq(matched_idxs, _52)
        _53 = ops.prim.dtype(labels_per_image2)
        _54 = ops.prim.device(labels_per_image2)
        _55 = torch.tensor(0., dtype=_53, device=_54, requires_grad=False)
        _56 = annotate(List[Optional[Tensor]], [bg_indices])
        _57 = torch.index_put_(labels_per_image2, _56, _55, False)
        _58 = self.proposal_matcher.BETWEEN_THRESHOLDS
        inds_to_discard = torch.eq(matched_idxs, _58)
        _59 = ops.prim.dtype(labels_per_image2)
        _60 = ops.prim.device(labels_per_image2)
        _61 = torch.tensor(-1., dtype=_59, device=_60, requires_grad=False)
        _62 = annotate(List[Optional[Tensor]], [inds_to_discard])
        _63 = torch.index_put_(labels_per_image2, _62, _61, False)
        labels_per_image, matched_gt_boxes_per_image = labels_per_image2, matched_gt_boxes_per_image1
      _64 = torch.append(labels, labels_per_image)
      _65 = torch.append(matched_gt_boxes, matched_gt_boxes_per_image)
    return (labels, matched_gt_boxes)
  def compute_loss(self: __torch__.torchvision.models.detection.rpn.RegionProposalNetwork,
    objectness: Tensor,
    pred_bbox_deltas: Tensor,
    labels: List[Tensor],
    regression_targets: List[Tensor]) -> Tuple[Tensor, Tensor]:
    _66 = __torch__.torchvision.models.detection._utils.smooth_l1_loss
    _67 = __torch__.torch.nn.functional.binary_cross_entropy_with_logits
    _68 = (self.fg_bg_sampler).__call__(labels, )
    sampled_pos_inds, sampled_neg_inds, = _68
    _69 = torch.where(torch.cat(sampled_pos_inds, 0))
    sampled_pos_inds0 = _69[0]
    _70 = torch.where(torch.cat(sampled_neg_inds, 0))
    sampled_neg_inds0 = _70[0]
    _71 = [sampled_pos_inds0, sampled_neg_inds0]
    sampled_inds = torch.cat(_71, 0)
    objectness4 = torch.flatten(objectness, 0, -1)
    labels0 = torch.cat(labels, 0)
    regression_targets0 = torch.cat(regression_targets, 0)
    _72 = annotate(List[Optional[Tensor]], [sampled_pos_inds0])
    _73 = torch.index(pred_bbox_deltas, _72)
    _74 = annotate(List[Optional[Tensor]], [sampled_pos_inds0])
    _75 = torch.index(regression_targets0, _74)
    _76 = _66(_73, _75, 0.1111111111111111, False, )
    box_loss = torch.div(_76, torch.numel(sampled_inds))
    _77 = annotate(List[Optional[Tensor]], [sampled_inds])
    _78 = torch.index(objectness4, _77)
    _79 = annotate(List[Optional[Tensor]], [sampled_inds])
    objectness_loss = _67(_78, torch.index(labels0, _79), None, None, None, "mean", None, )
    return (objectness_loss, box_loss)
class RPNHead(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.torch.nn.modules.conv.___torch_mangle_70.Conv2d
  cls_logits : __torch__.torch.nn.modules.conv.___torch_mangle_72.Conv2d
  bbox_pred : __torch__.torch.nn.modules.conv.___torch_mangle_73.Conv2d
  def forward(self: __torch__.torchvision.models.detection.rpn.RPNHead,
    x: List[Tensor]) -> Tuple[List[Tensor], List[Tensor]]:
    logits = annotate(List[Tensor], [])
    bbox_reg = annotate(List[Tensor], [])
    for _80 in range(torch.len(x)):
      feature = x[_80]
      t = __torch__.torch.nn.functional.relu((self.conv).forward(feature, ), False, )
      _81 = torch.append(logits, (self.cls_logits).forward(t, ))
      _82 = torch.append(bbox_reg, (self.bbox_pred).forward(t, ))
    return (logits, bbox_reg)
def concat_box_prediction_layers(box_cls: List[Tensor],
    box_regression: List[Tensor]) -> Tuple[Tensor, Tensor]:
  _83 = __torch__.torchvision.models.detection.rpn.permute_and_flatten
  box_cls_flattened = annotate(List[Tensor], [])
  box_regression_flattened = annotate(List[Tensor], [])
  _84 = [torch.len(box_cls), torch.len(box_regression)]
  for _85 in range(ops.prim.min(_84)):
    box_cls_per_level = box_cls[_85]
    box_regression_per_level = box_regression[_85]
    N, AxC, H, W, = torch.size(box_cls_per_level)
    _86 = torch.size(box_regression_per_level)
    Ax4 = _86[1]
    A = torch.floordiv(Ax4, 4)
    C = torch.floordiv(AxC, A)
    box_cls_per_level0 = _83(box_cls_per_level, N, A, C, H, W, )
    _87 = torch.append(box_cls_flattened, box_cls_per_level0)
    box_regression_per_level0 = _83(box_regression_per_level, N, A, 4, H, W, )
    _88 = torch.append(box_regression_flattened, box_regression_per_level0)
  box_cls0 = torch.flatten(torch.cat(box_cls_flattened, 1), 0, -2)
  _89 = torch.cat(box_regression_flattened, 1)
  box_regression0 = torch.reshape(_89, [-1, 4])
  return (box_cls0, box_regression0)
def permute_and_flatten(layer: Tensor,
    N: int,
    A: int,
    C: int,
    H: int,
    W: int) -> Tensor:
  layer0 = torch.view(layer, [N, -1, C, H, W])
  layer1 = torch.permute(layer0, [0, 3, 4, 1, 2])
  return torch.reshape(layer1, [N, -1, C])
