class GeneralizedRCNNTransform(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  min_size : Tuple[int]
  max_size : int
  image_mean : List[float]
  image_std : List[float]
  def forward(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    images: List[Tensor],
    targets: Optional[List[Dict[str, Tensor]]]=None) -> Tuple[__torch__.torchvision.models.detection.image_list.ImageList, Optional[List[Dict[str, Tensor]]]]:
    _0 = "images is expected to be a list of 3d tensors of shape [C, H, W], got {}"
    images0 = annotate(List[Tensor], [])
    for _1 in range(torch.len(images)):
      img = images[_1]
      _2 = torch.append(images0, img)
    if torch.__isnot__(targets, None):
      targets1 = unchecked_cast(List[Dict[str, Tensor]], targets)
      targets_copy = annotate(List[Dict[str, Tensor]], [])
      for _3 in range(torch.len(targets1)):
        t = targets1[_3]
        data = annotate(Dict[str, Tensor], {})
        _4 = torch.items(t)
        for _5 in range(torch.len(_4)):
          k, v, = _4[_5]
          torch._set_item(data, k, v)
        _6 = torch.append(targets_copy, data)
      targets0 = targets_copy
    else:
      targets0 = targets
    targets2 = targets0
    for i in range(torch.len(images0)):
      image = images0[i]
      if torch.__isnot__(targets2, None):
        targets4 = unchecked_cast(List[Dict[str, Tensor]], targets2)
        target_index, targets3 = targets4[i], targets4
      else:
        target_index, targets3 = None, targets2
      if torch.ne(torch.dim(image), 3):
        _7 = torch.format(_0, torch.size(image))
        ops.prim.RaiseException(_7)
      else:
        pass
      image0 = (self).normalize(image, )
      _8 = (self).resize(image0, target_index, )
      image1, target_index0, = _8
      _9 = torch._set_item(images0, i, image1)
      if torch.__isnot__(targets3, None):
        targets6 = unchecked_cast(List[Dict[str, Tensor]], targets3)
        _11 = torch.__isnot__(target_index0, None)
        _10, targets5 = _11, targets6
      else:
        _10, targets5 = False, targets3
      if _10:
        targets8 = unchecked_cast(List[Dict[str, Tensor]], targets5)
        target_index1 = unchecked_cast(Dict[str, Tensor], target_index0)
        _12 = torch._set_item(targets8, i, target_index1)
        targets7 = targets8
      else:
        targets7 = targets5
      targets2 = targets7
    image_sizes = annotate(List[List[int]], [])
    for _13 in range(torch.len(images0)):
      img0 = images0[_13]
      _14 = torch.slice(torch.size(img0), -2, 9223372036854775807, 1)
      _15 = torch.append(image_sizes, _14)
    images1 = (self).batch_images(images0, 32, )
    image_sizes_list = annotate(List[Tuple[int, int]], [])
    for _16 in range(torch.len(image_sizes)):
      image_size = image_sizes[_16]
      _17 = torch.eq(torch.len(image_size), 2)
      if _17:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _18 = torch.append(image_sizes_list, (image_size[0], image_size[1]))
    image_list = __torch__.torchvision.models.detection.image_list.ImageList.__new__(__torch__.torchvision.models.detection.image_list.ImageList)
    _19 = (image_list).__init__(images1, image_sizes_list, )
    return (image_list, targets2)
  def normalize(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    image: Tensor) -> Tensor:
    _20 = "Expected input images to be of floating type (in range [0, 1]), but found type {} instead"
    _21 = torch.__not__(torch.is_floating_point(image))
    if _21:
      _22 = torch.format(_20, ops.prim.dtype(image))
      ops.prim.RaiseException(_22)
    else:
      pass
    dtype = ops.prim.dtype(image)
    device = ops.prim.device(image)
    mean = torch.as_tensor(self.image_mean, dtype=dtype, device=device)
    std = torch.as_tensor(self.image_std, dtype=dtype, device=device)
    _23 = torch.slice(mean, 0, 0, 9223372036854775807, 1)
    _24 = torch.unsqueeze(torch.unsqueeze(_23, 1), 2)
    _25 = torch.sub(image, _24, alpha=1)
    _26 = torch.slice(std, 0, 0, 9223372036854775807, 1)
    _27 = torch.unsqueeze(torch.unsqueeze(_26, 1), 2)
    return torch.div(_25, _27)
  def resize(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    image: Tensor,
    target: Optional[Dict[str, Tensor]]) -> Tuple[Tensor, Optional[Dict[str, Tensor]]]:
    _28 = "This Python function is annotated to be ignored and cannot be run"
    _29 = __torch__.torchvision.models.detection.transform._resize_image_and_masks
    _30 = __torch__.torchvision.models.detection.transform.resize_boxes
    _31 = __torch__.torchvision.models.detection.transform.resize_keypoints
    _32 = uninitialized(Optional[Dict[str, Tensor]])
    _33 = uninitialized(Tensor)
    _34 = torch.slice(torch.size(image), -2, 9223372036854775807, 1)
    h, w, = _34
    if self.training:
      _35, = self.min_size
      size0 = float((self).torch_choice([_35], ))
      size = size0
    else:
      size = float((self.min_size)[-1])
    if __torch__.torchvision._is_tracing():
      ops.prim.RaiseException(_28)
      target0, image2 = _32, _33
    else:
      _36 = _29(image, size, float(self.max_size), target, )
      image3, target1, = _36
      target0, image2 = target1, image3
    if torch.__is__(target0, None):
      _37 = (image2, target0)
    else:
      target2 = unchecked_cast(Dict[str, Tensor], target0)
      bbox = target2["boxes"]
      _38 = torch.slice(torch.size(image2), -2, 9223372036854775807, 1)
      bbox0 = _30(bbox, [h, w], _38, )
      torch._set_item(target2, "boxes", bbox0)
      _39 = torch.__contains__(target2, "keypoints")
      if _39:
        keypoints = target2["keypoints"]
        _40 = torch.slice(torch.size(image2), -2, 9223372036854775807, 1)
        keypoints0 = _31(keypoints, [h, w], _40, )
        torch._set_item(target2, "keypoints", keypoints0)
      else:
        pass
      _37 = (image2, target2)
    return _37
  def torch_choice(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    k: List[int]) -> int:
    _41 = torch.empty([1], dtype=None, layout=None, device=None, pin_memory=None, memory_format=None)
    _42 = torch.uniform_(_41, 0., float(torch.len(k)), generator=None)
    index = int(torch.item(_42))
    return k[index]
  def batch_images(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    images: List[Tensor],
    size_divisible: int=32) -> Tensor:
    _43 = "This Python function is annotated to be ignored and cannot be run"
    if __torch__.torchvision._is_tracing():
      ops.prim.RaiseException(_43)
    else:
      pass
    _44 = annotate(List[List[int]], [])
    for _45 in range(torch.len(images)):
      img = images[_45]
      _46 = torch.append(_44, torch.list(torch.size(img)))
    max_size = (self).max_by_axis(_44, )
    stride = float(size_divisible)
    max_size0 = torch.list(max_size)
    _47 = torch.div(float(max_size0[1]), stride)
    _48 = int(torch.mul(torch.ceil(_47), stride))
    _49 = torch._set_item(max_size0, 1, _48)
    _50 = torch.div(float(max_size0[2]), stride)
    _51 = int(torch.mul(torch.ceil(_50), stride))
    _52 = torch._set_item(max_size0, 2, _51)
    batch_shape = torch.add([torch.len(images)], max_size0)
    batched_imgs = torch.new_full(images[0], batch_shape, 0, dtype=None, layout=None, device=None, pin_memory=None)
    _53 = [torch.len(images), torch.len(batched_imgs)]
    for _54 in range(ops.prim.min(_53)):
      img1 = images[_54]
      pad_img = torch.select(batched_imgs, 0, _54)
      _55 = torch.slice(pad_img, 0, 0, (torch.size(img1))[0], 1)
      _56 = torch.slice(_55, 1, 0, (torch.size(img1))[1], 1)
      _57 = torch.slice(_56, 2, 0, (torch.size(img1))[2], 1)
      _58 = torch.copy_(_57, img1, False)
    return batched_imgs
  def max_by_axis(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    the_list: List[List[int]]) -> List[int]:
    maxes = the_list[0]
    _59 = torch.slice(the_list, 1, 9223372036854775807, 1)
    for _60 in range(torch.len(_59)):
      sublist = _59[_60]
      _61 = [9223372036854775807, torch.len(sublist)]
      for index in range(ops.prim.min(_61)):
        item = sublist[index]
        _62 = ops.prim.max(maxes[index], item)
        _63 = torch._set_item(maxes, index, _62)
    return maxes
  def postprocess(self: __torch__.torchvision.models.detection.transform.GeneralizedRCNNTransform,
    result: List[Dict[str, Tensor]],
    image_shapes: List[Tuple[int, int]],
    original_image_sizes: List[Tuple[int, int]]) -> List[Dict[str, Tensor]]:
    _64 = __torch__.torchvision.models.detection.transform.resize_boxes
    _65 = __torch__.torchvision.models.detection.roi_heads.paste_masks_in_image
    _66 = __torch__.torchvision.models.detection.transform.resize_keypoints
    if self.training:
      pass
    else:
      _67 = [9223372036854775807, torch.len(result), torch.len(image_shapes), torch.len(original_image_sizes)]
      for i in range(ops.prim.min(_67)):
        pred = result[i]
        im_s = image_shapes[i]
        o_im_s = original_image_sizes[i]
        boxes = pred["boxes"]
        _68, _69, = im_s
        _70 = [_68, _69]
        _71, _72, = o_im_s
        boxes0 = _64(boxes, _70, [_71, _72], )
        torch._set_item(result[i], "boxes", boxes0)
        _73 = torch.__contains__(pred, "masks")
        if _73:
          masks = pred["masks"]
          masks0 = _65(masks, boxes0, o_im_s, 1, )
          torch._set_item(result[i], "masks", masks0)
        else:
          pass
        _74 = torch.__contains__(pred, "keypoints")
        if _74:
          keypoints = pred["keypoints"]
          _75, _76, = im_s
          _77 = [_75, _76]
          _78, _79, = o_im_s
          keypoints1 = _66(keypoints, _77, [_78, _79], )
          torch._set_item(result[i], "keypoints", keypoints1)
        else:
          pass
    return result
def _resize_image_and_masks(image: Tensor,
    self_min_size: float,
    self_max_size: float,
    target: Optional[Dict[str, Tensor]]) -> Tuple[Tensor, Optional[Dict[str, Tensor]]]:
  _80 = __torch__.torch.nn.functional.___torch_mangle_78.interpolate
  _81 = torch.slice(torch.size(image), -2, 9223372036854775807, 1)
  im_shape = torch.tensor(_81, dtype=None, device=None, requires_grad=False)
  min_size = float(torch.min(im_shape))
  max_size = float(torch.max(im_shape))
  scale_factor = torch.div(self_min_size, min_size)
  _82 = torch.gt(torch.mul(max_size, scale_factor), self_max_size)
  if _82:
    scale_factor0 = torch.div(self_max_size, max_size)
  else:
    scale_factor0 = scale_factor
  _83 = _80(torch.unsqueeze(image, 0), None, scale_factor0, "bilinear", False, True, )
  image4 = torch.select(_83, 0, 0)
  if torch.__is__(target, None):
    _84 = (image4, target)
  else:
    target3 = unchecked_cast(Dict[str, Tensor], target)
    _85 = torch.__contains__(target3, "masks")
    if _85:
      mask = target3["masks"]
      _86 = torch.slice(mask, 0, 0, 9223372036854775807, 1)
      _87 = torch.to(torch.unsqueeze(_86, 1), 6, False, False, None)
      _88 = _80(_87, None, scale_factor0, "nearest", None, True, )
      _89 = torch.slice(_88, 0, 0, 9223372036854775807, 1)
      mask0 = torch.to(torch.select(_89, 1, 0), 0, False, False, None)
      torch._set_item(target3, "masks", mask0)
    else:
      pass
    _84 = (image4, target3)
  return _84
def resize_boxes(boxes: Tensor,
    original_size: List[int],
    new_size: List[int]) -> Tensor:
  ratios = annotate(List[Tensor], [])
  _90 = [torch.len(new_size), torch.len(original_size)]
  for _91 in range(ops.prim.min(_90)):
    s = new_size[_91]
    s_orig = original_size[_91]
    _92 = torch.tensor(s, dtype=6, device=ops.prim.device(boxes), requires_grad=False)
    _93 = torch.tensor(s_orig, dtype=6, device=ops.prim.device(boxes), requires_grad=False)
    _94 = torch.append(ratios, torch.div(_92, _93))
  ratio_height, ratio_width, = ratios
  xmin, ymin, xmax, ymax, = torch.unbind(boxes, 1)
  xmin0 = torch.mul(xmin, ratio_width)
  xmax0 = torch.mul(xmax, ratio_width)
  ymin0 = torch.mul(ymin, ratio_height)
  ymax0 = torch.mul(ymax, ratio_height)
  _95 = torch.stack([xmin0, ymin0, xmax0, ymax0], 1)
  return _95
def resize_keypoints(keypoints: Tensor,
    original_size: List[int],
    new_size: List[int]) -> Tensor:
  ratios = annotate(List[Tensor], [])
  _96 = [torch.len(new_size), torch.len(original_size)]
  for _97 in range(ops.prim.min(_96)):
    s = new_size[_97]
    s_orig = original_size[_97]
    _98 = torch.tensor(s, dtype=6, device=ops.prim.device(keypoints), requires_grad=False)
    _99 = torch.tensor(s_orig, dtype=6, device=ops.prim.device(keypoints), requires_grad=False)
    _100 = torch.append(ratios, torch.div(_98, _99))
  ratio_h, ratio_w, = ratios
  resized_data = torch.clone(keypoints, memory_format=None)
  _101 = torch.mul_(torch.select(resized_data, -1, 0), ratio_w)
  _102 = torch.mul_(torch.select(resized_data, -1, 1), ratio_h)
  return resized_data
