def clip_boxes_to_image(boxes: Tensor,
    size: Tuple[int, int]) -> Tensor:
  dim = torch.dim(boxes)
  boxes_x = torch.slice(boxes, -1, 0, 9223372036854775807, 2)
  boxes_y = torch.slice(boxes, -1, 1, 9223372036854775807, 2)
  height, width, = size
  if __torch__.torchvision._is_tracing():
    _0 = torch.tensor(0, dtype=ops.prim.dtype(boxes), device=ops.prim.device(boxes), requires_grad=False)
    boxes_x1 = torch.max(boxes_x, _0)
    _1 = torch.tensor(width, dtype=ops.prim.dtype(boxes), device=ops.prim.device(boxes), requires_grad=False)
    boxes_x2 = torch.min(boxes_x1, _1)
    _2 = torch.tensor(0, dtype=ops.prim.dtype(boxes), device=ops.prim.device(boxes), requires_grad=False)
    boxes_y1 = torch.max(boxes_y, _2)
    _3 = torch.tensor(height, dtype=ops.prim.dtype(boxes), device=ops.prim.device(boxes), requires_grad=False)
    boxes_x0, boxes_y0 = boxes_x2, torch.min(boxes_y1, _3)
  else:
    boxes_x0, boxes_y0 = torch.clamp(boxes_x, 0, width), torch.clamp(boxes_y, 0, height)
  clipped_boxes = torch.stack([boxes_x0, boxes_y0], dim)
  _4 = torch.reshape(clipped_boxes, torch.size(boxes))
  return _4
def remove_small_boxes(boxes: Tensor,
    min_size: float) -> Tensor:
  _5 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _6 = torch.select(_5, 1, 2)
  _7 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  ws = torch.sub(_6, torch.select(_7, 1, 0), alpha=1)
  _8 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  _9 = torch.select(_8, 1, 3)
  _10 = torch.slice(boxes, 0, 0, 9223372036854775807, 1)
  hs = torch.sub(_9, torch.select(_10, 1, 1), alpha=1)
  keep = torch.__and__(torch.ge(ws, min_size), torch.ge(hs, min_size))
  return (torch.where(keep))[0]
def batched_nms(boxes: Tensor,
    scores: Tensor,
    idxs: Tensor,
    iou_threshold: float) -> Tensor:
  if torch.eq(torch.numel(boxes), 0):
    _12 = ops.prim.device(boxes)
    _13 = torch.empty([0], dtype=4, layout=None, device=_12, pin_memory=None, memory_format=None)
    _11 = _13
  else:
    max_coordinate = torch.max(boxes)
    _14 = torch.to(idxs, boxes, False, False, None)
    _15 = torch.tensor(1, dtype=None, device=None, requires_grad=False)
    _16 = torch.to(_15, boxes, False, False, None)
    _17 = torch.add(max_coordinate, _16, alpha=1)
    offsets = torch.mul(_14, _17)
    _18 = torch.slice(offsets, 0, 0, 9223372036854775807, 1)
    boxes_for_nms = torch.add(boxes, torch.unsqueeze(_18, 1), alpha=1)
    keep = __torch__.torchvision.ops.boxes.nms(boxes_for_nms, scores, iou_threshold, )
    _11 = keep
  return _11
def box_iou(boxes1: Tensor,
    boxes2: Tensor) -> Tensor:
  _19 = __torch__.torchvision.ops.boxes._box_inter_union
  inter, union, = _19(boxes1, boxes2, )
  return torch.div(inter, union)
def box_area(boxes: Tensor) -> Tensor:
  _20 = __torch__.torchvision.ops.boxes._upcast
  boxes0 = _20(boxes, )
  _21 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
  _22 = torch.select(_21, 1, 2)
  _23 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
  _24 = torch.sub(_22, torch.select(_23, 1, 0), alpha=1)
  _25 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
  _26 = torch.select(_25, 1, 3)
  _27 = torch.slice(boxes0, 0, 0, 9223372036854775807, 1)
  _28 = torch.sub(_26, torch.select(_27, 1, 1), alpha=1)
  return torch.mul(_24, _28)
def nms(boxes: Tensor,
    scores: Tensor,
    iou_threshold: float) -> Tensor:
  _29 = __torch__.torchvision.extension._assert_has_ops
  _30 = _29()
  _31 = ops.torchvision.nms(boxes, scores, iou_threshold)
  return _31
def _box_inter_union(boxes1: Tensor,
    boxes2: Tensor) -> Tuple[Tensor, Tensor]:
  _32 = __torch__.torchvision.ops.boxes.box_area
  _33 = __torch__.torchvision.ops.boxes._upcast
  area1 = _32(boxes1, )
  area2 = _32(boxes2, )
  _34 = torch.slice(boxes1, 0, 0, 9223372036854775807, 1)
  _35 = torch.slice(torch.unsqueeze(_34, 1), 2, 0, 2, 1)
  _36 = torch.slice(boxes2, 0, 0, 9223372036854775807, 1)
  lt = torch.max(_35, torch.slice(_36, 1, 0, 2, 1))
  _37 = torch.slice(boxes1, 0, 0, 9223372036854775807, 1)
  _38 = torch.slice(torch.unsqueeze(_37, 1), 2, 2, 9223372036854775807, 1)
  _39 = torch.slice(boxes2, 0, 0, 9223372036854775807, 1)
  _40 = torch.slice(_39, 1, 2, 9223372036854775807, 1)
  rb = torch.min(_38, _40)
  wh = torch.clamp(_33(torch.sub(rb, lt, alpha=1), ), 0, None)
  _41 = torch.slice(wh, 0, 0, 9223372036854775807, 1)
  _42 = torch.slice(_41, 1, 0, 9223372036854775807, 1)
  _43 = torch.select(_42, 2, 0)
  _44 = torch.slice(wh, 0, 0, 9223372036854775807, 1)
  _45 = torch.slice(_44, 1, 0, 9223372036854775807, 1)
  inter = torch.mul(_43, torch.select(_45, 2, 1))
  _46 = torch.slice(area1, 0, 0, 9223372036854775807, 1)
  _47 = torch.add(torch.unsqueeze(_46, 1), area2, alpha=1)
  union = torch.sub(_47, inter, alpha=1)
  return (inter, union)
def _upcast(t: Tensor) -> Tensor:
  if torch.is_floating_point(t):
    _49 = ops.prim.dtype(t)
    if torch.__contains__([6, 7], _49):
      _50 = t
    else:
      _51 = torch.to(t, 6, False, False, None)
      _50 = _51
    _48 = _50
  else:
    _52 = ops.prim.dtype(t)
    if torch.__contains__([3, 4], _52):
      _53 = t
    else:
      _54 = torch.to(t, 3, False, False, None)
      _53 = _54
    _48 = _53
  return _48
