class FrozenBatchNorm2d(Module):
  __parameters__ = []
  __buffers__ = ["weight", "bias", "running_mean", "running_var", ]
  weight : Tensor
  bias : Tensor
  running_mean : Tensor
  running_var : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  eps : float
  def forward(self: __torch__.torchvision.ops.misc.FrozenBatchNorm2d,
    x: Tensor) -> Tensor:
    w = torch.reshape(self.weight, [1, -1, 1, 1])
    b = torch.reshape(self.bias, [1, -1, 1, 1])
    rv = torch.reshape(self.running_var, [1, -1, 1, 1])
    rm = torch.reshape(self.running_mean, [1, -1, 1, 1])
    _0 = torch.rsqrt(torch.add(rv, self.eps, 1))
    scale = torch.mul(w, _0)
    bias = torch.sub(b, torch.mul(rm, scale), alpha=1)
    _1 = torch.add(torch.mul(x, scale), bias, alpha=1)
    return _1
